/*<go32win.c>*/
/* ================================================================
 * Go32win(GO32 Clone DOS Extender for Windows 3.1) specific Patch and
 * utilities. 
 *
 * 		Copyright (C) 1995 TM WorkS / Y.Matsushima
 *		This file is distributed under the term of GNU GPL.
 *
 * 		'95/02/26	1st.wr.
 *		    03/05	patchlevel-1 fixup.
 *		    06/01	for Mule-2.2.2
 *			07/04	patchlevel-2 fixup.
 * ================================================================
 */

/* 
 * ================================================================
 * DPMI ł̃X^bÑIvV
 *
 * Mule N Abort ꍇADPMI_STACK_PRE_ALLOC ̒l
 * 邱ƂŖ肪P\L܂B
 * ================================================================
 */
#define DPMI_STACK_PRE_ALLOC 16	/* 4  16 炢͈̔͂Ŏw肷 */
/* #define BUILD_DPMI_STACK_DOS */	/* DOS p̃X^bNR[h */
#define LIGHT_STAT		/* 𔲂 stat() gp(CD-ROM) */
#ifdef BUILD_DPMI_STACK_DOS
#undef BUILD_DPMI_STACK_DOS	/* 95.6.25 by K.Fujii */
#endif

#include <stddef.h>
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <dos.h>
#include <errno.h>
#include <dir.h>
#include <dirent.h>
#include <string.h>
#include <ctype.h>
#include <jctype.h>
#include <go32.h>
#include <config.h>
#include <time.h>
#include <sys/time.h>
#include <tzfile.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <unistd.h>
#include <dpmi.h>
#include "termchar.h"
/*#include "termopts.h"*/
/*#include "cm.h"*/
#include "msdos.h"
#include "lisp.h"
#include "frame.h"
/*#include "disptab.h"*/
#include "window.h"
#include "dispexte.h"
#include "termhooks.h"
#include "keyboard.h"
#include "systime.h"
#include "charset.h"
#include "coding.h"
extern struct face *intern_face ();

#define _GO32WIN_H_MACRO
#include "go32win.h"


int __crt0_mtype;
extern int __malloc_initialized; /* gmalloc Initialize flag */

static int vdpmi = 0x31;
static union REGS r;
static struct SREGS s;

#define VMULE 0x32				/* go32win Mule function vector */
#define GENORG(org, dumee) org

static unsigned retAX(unsigned req){
  r.x.ax = req;
  int86((req & 0xffff0000)? VMULE: 0x21, &r, &r);
  return r.x.ax;
}

/* 
 * ================================================================
 * screen				VMULE 32310001~
 * ================================================================
 */
int ScreenCols(void){
  return (int)retAX(0x32310001);
}

int ScreenRows(void){
  return (int)retAX(0x32310002);
}

/* 
 * ================================================================
 * clock				VMULE 32310003
 * ================================================================
 */
long clock(){
  return (unsigned long)retAX(0x32310003);
}

/* 
 * ================================================================
 * fepctrl				int21h 0000ffxx
 * ================================================================
 */
int fep_init(void){
  return (retAX(0xff14)? 4: 0);
}

void fep_term(void){
  retAX(0xff15);
}

void fep_on(void){
  retAX(0xff16);
}

void fep_off(void){
  retAX(0xff17);
}

void fep_force_on(void){
  retAX(0xff18);
}

void fep_force_off(void){
  retAX(0xff19);
}

#if 0
int	go32win_fep_raw_init(){
  return go32win_fep_init();
}

void go32win_fep_raw_term(){
  go32win_fep_term();
}
#endif

int	fep_get_mode(void){
  return (int)retAX(0xff1a);
}

/* patch 95.4.1 K.Fujii */
/* ===================================================
 * go32func.c
 * ===================================================
 */

u_short _go32_my_cs()
{
  register short rv;
  asm("movw %%cs,%0" : "=r" (rv));
  return rv;
}

u_short _go32_my_ds()
{
  register short rv;
  asm("movw %%ds,%0" : "=r" (rv));
  return rv;
}

u_short _go32_my_ss()
{
  register short rv;
  asm("movw %%ss,%0" : "=r" (rv));
  return rv;
}

u_long _go32_my_esp()
{
  register long rv;
  asm("movl %%esp,%0" : "=r" (rv));
  return rv;
}

u_short _go32_conventional_mem_selector()
{
  return _go32_info_block.selector_for_linear_memory;
}

static _go32_dpmi_registers regs;
static volatile u_long ctrl_break_count = 0;
static int ctrl_break_hooked = 0;
#if 0
static _go32_dpmi_seginfo old_vector;
static _go32_dpmi_seginfo new_vector;
static int stop_vector[]={
  0x1b,  /* for pcAT */
  0x06,  /* for pc98 */
};
#endif

static void ctrl_break_isr(_go32_dpmi_registers *regs)
{
  ctrl_break_count ++;
}

u_long _go32_was_ctrl_break_hit()
{
  u_long cnt;
  _go32_want_ctrl_break(1);
  cnt = ctrl_break_count;
  ctrl_break_count = 0;
  return cnt;
}

void _go32_want_ctrl_break(int yes)
{
  if (yes)
    {
      if (ctrl_break_hooked)
	return;

      ctrl_break_count = 0;
      ctrl_break_hooked = 1;
    }
  else
    {
      if (!ctrl_break_hooked)
	return;

      ctrl_break_count = 0;
      ctrl_break_hooked = 0;
    }
}

/* ==================================================
 * access.c
 * ==================================================
 */
#ifdef access
#undef access
#endif

int access(const char *vfn, int flags)
{
  struct stat s;

  if( stat(vfn, &s) ) return -1;
  if( s.st_mode & (S_IFDIR|S_IFCHR) ) return 0;
  if( (flags & W_OK) && !(s.st_mode & S_IWUSR) ) return -1;
  if( (flags & X_OK) && !(s.st_mode & S_IXUSR) ) return -1;
  if( !(s.st_mode & S_IFREG) ) return -1;
  return 0;           /* everything else is OK */
}
/* end of patch */

/* patch 96.3.17  by K.Fujii */
/*
 * ================================================================
 * fixpath.c
 * ================================================================
 */
int
_get_default_drive(void)
{
    union REGS	regs;

    regs.h.ah = 0x19;		/* DOS Get Default Drive call */
    regs.h.al = 0;
    (void) intdos(&regs, &regs);
    return regs.h.al;
}

static unsigned char *
get_current_directory(unsigned char *out, int drive_number)
{
    union REGS	regs;

    regs.h.ah = 0x47;
    regs.h.dl = drive_number + 1;
    regs.x.si = (unsigned long) (out + 1);
    (void) intdos(&regs, &regs);
    if (regs.x.cflag != 0)
    {
	errno = regs.x.ax;
	return out;
    }
    else
    {
	/* Root path, don't insert "/", it'll be added later */
	if (*(out + 1) != '\0')
	    *out = '/';
	else
	    *out = '\0';
	return out + strlen(out);
    }
}

static int
is_slash(int c)
{
    return c == '/' || c == '\\';
}

static int
is_term(int c)
{
    return c == '/' || c == '\\' || c == '\0';
}
  
static int
is_sep(int c)
{
    return c == '/' || c == '\\' || c == '.' || c == '\0';
}

/* Takes as input an arbitrary path.  Fixes up the path by:
   1. Removing consecutive slashes
   2. Removing trailing slashes
   3. Making the path absolute if it wasn't already
   4. Removing "." in the path
   5. Removing ".." entries in the path (and the directory above them)
   6. Adding a drive specification if one wasn't there
   7. Converting all slashes to '/'
   8. Converting to lowercase
   9. Stripping characters that would be ignored by MS-DOS
 */
void
_fixpath(const char *in, char *out)
{
    int		drive_number, count;
    const unsigned char	*ip = (unsigned char *)in;
    unsigned char	*op = (unsigned char *)out;
    unsigned char	*p;

    /* Add drive specification to output string */
    if (*(ip + 1) == ':' && ((*ip >= 'a' && *ip <= 'z') ||
			     (*ip >= 'A' && *ip <= 'Z')))
    {
	if (*ip >= 'a' && *ip <= 'z')
	    drive_number = *ip - 'a';
	else
	    drive_number = *ip - 'A';
	*op++ = tolower(*ip++);
	*op++ = tolower(*ip++);
    }
    else
    {
	drive_number = _get_default_drive();
	*op++ = drive_number + 'a';
	*op++ = ':';
    }

    /* Convert relative path to absolute */
    if (!is_slash(*ip))
    {
	p = op;
  	op = get_current_directory(op, drive_number);
	/* Convert path to lowercase, in case it wasn't already */
	while (p < op)
	{
	  if (iskanji (*p) && iskanji2 (p[1]))
	    p++;
	  else if (*p >= 'A' && *p <= 'Z')
	    *p |= 0x20;
	  p++;
	}
    }

    /* Step through the input path */
    while (*ip != '\0')
    {
	/* Skip input slashes */
	if (is_slash(*ip))
	{
	    ip++;
	    continue;
	}

	/* Skip "." and output nothing */
	if (*ip == '.' && is_term(*(ip + 1)))
	{
	    ip++;
	    continue;
	}

	/* Skip ".." and remove previous output directory */
	if (*ip == '.' && *(ip + 1) == '.' && is_term(*(ip + 2)))
	{
	    ip += 2;
	    /* Don't back up over drive spec */
	    if (op > (unsigned char *)(out + 2))
		/* This requires "/" to follow drive spec */
		while (!is_slash(*--op));
	    continue;
	}

	/* Copy path component from in to out */
	*op++ = '/';
	count = 0;
	/* Copy up to eight characters in filename */
	while (!is_sep(*ip))
	{
	  if (count++ < 8)
	    {
	      if (iskanji (*ip) && iskanji2 (ip[1]))
		count++, *op++ = *ip++, *op++ = *ip;
	      else if (*ip >= 'A' && *ip <= 'Z')
		*op++ = *ip | 0x20;
	      else
		*op++ = *ip;
	    }
	  ip++;
	}
	/* Copy dot */
	if (*ip == '.')
	    *op++ = *ip++;
	count = 0;
	/* Copy up to three characters in extension */
	while (!is_sep(*ip))
	{
	  if (count++ < 3)
	    {
	      if (iskanji (*ip) && iskanji2 (ip[1]))
		count++, *op++ = *ip++, *op++ = *ip;
	      else if (*ip >= 'A' && *ip <= 'Z')
		*op++ = *ip | 0x20;
	      else
		*op++ = *ip;
	    }
	  ip++;
	}
	/* Copy dot */
	if (*ip == '.')
	    *op++ = *ip++;
	/* Skip over extra garbage in the input path */
	while (!is_term(*ip)) ip++;
    }

    /* If root directory, insert trailing slash */
    if (op == (unsigned char *)(out + 2)) *op++ = '/';

    /* Null terminate the output */
    *op = '\0';
}

/* ================================================================
 * CTIME.C
 * ================================================================
 */
/* This is file CTIME.C */
/* This file may have been modified by DJ Delorie (Jan 1991).  If so,
** these modifications are Coyright (C) 1993 DJ Delorie, 24 Kirsten Ave,
** Rochester NH, 03867-2954, USA.
*/

/*
 * Copyright (c) 1987, 1989 Regents of the University of California.
 * All rights reserved.
 *
 * This code is derived from software contributed to Berkeley by
 * Arthur David Olson of the National Cancer Institute.
 *
 * Redistribution and use in source and binary forms are permitted provided
 * that: (1) source distributions retain this entire copyright notice and
 * comment, and (2) distributions including binaries display the following
 * acknowledgement:  ``This product includes software developed by the
 * University of California, Berkeley and its contributors'' in the
 * documentation or other materials provided with the distribution and in
 * all advertising materials mentioning features or use of this software.
 * Neither the name of the University nor the names of its contributors may
 * be used to endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifdef tzset
#undef tzset
#endif

#if defined(LIBC_SCCS) && !defined(lint)
static char sccsid[] = "@(#)ctime.c	5.23 (Berkeley) 6/22/90";
#endif /* LIBC_SCCS and not lint */

/*
** Leap second handling from Bradley White (bww@k.gp.cs.cmu.edu).
** POSIX-style TZ environment variable handling from Guy Harris
** (guy@auspex.com).
*/

/*LINTLIBRARY*/

#ifdef __STDC__

#define P(s)		s
#define alloc_size_t	size_t
#define qsort_size_t	size_t
#define fread_size_t	size_t
#define fwrite_size_t	size_t

#else /* !defined __STDC__ */

#define P(s)		()
#define const
#define volatile

typedef char *		genericptr_t;
typedef unsigned	alloc_size_t;
typedef int		qsort_size_t;
typedef int		fread_size_t;
typedef int		fwrite_size_t;

extern char *	calloc();
extern char *	malloc();
extern char *	realloc();
extern char *	getenv();

#endif /* !defined __STDC__ */

extern unsigned long	time();

#define ACCESS_MODE	O_RDONLY|O_BINARY
#define OPEN_MODE	O_RDONLY|O_BINARY

#ifndef WILDABBR
/*
** Someone might make incorrect use of a time zone abbreviation:
**	1.	They might reference tzname[0] before calling tzset (explicitly
**	 	or implicitly).
**	2.	They might reference tzname[1] before calling tzset (explicitly
**	 	or implicitly).
**	3.	They might reference tzname[1] after setting to a time zone
**		in which Daylight Saving Time is never observed.
**	4.	They might reference tzname[0] after setting to a time zone
**		in which Standard Time is never observed.
**	5.	They might reference tm.TM_ZONE after calling offtime.
** What's best to do in the above cases is open to debate;
** for now, we just set things up so that in any of the five cases
** WILDABBR is used.  Another possibility:  initialize tzname[0] to the
** string "tzname[0] used before set", and similarly for the other cases.
** And another:  initialize tzname[0] to "ERA", with an explanation in the
** manual page of what this "time zone abbreviation" means (doing this so
** that tzname[0] has the "normal" length of three characters).
*/
#define WILDABBR	"   "
#endif /* !defined WILDABBR */

#ifndef TRUE
#define TRUE		1
#define FALSE		0
#endif /* !defined TRUE */

static const char GMT[] = "GMT";

struct ttinfo {				/* time type information */
	long		tt_gmtoff;	/* GMT offset in seconds */
	int		tt_isdst;	/* used to set tm_isdst */
	int		tt_abbrind;	/* abbreviation list index */
	int		tt_ttisstd;	/* TRUE if transition is std time */
};

struct lsinfo {				/* leap second information */
	time_t		ls_trans;	/* transition time */
	long		ls_corr;	/* correction to apply */
};

struct state {
	int		leapcnt;
	int		timecnt;
	int		typecnt;
	int		charcnt;
	time_t		ats[TZ_MAX_TIMES];
	unsigned char	types[TZ_MAX_TIMES];
	struct ttinfo	ttis[TZ_MAX_TYPES];
	char		chars[(TZ_MAX_CHARS + 1 > sizeof GMT) ?
				TZ_MAX_CHARS + 1 : sizeof GMT];
	struct lsinfo	lsis[TZ_MAX_LEAPS];
};

struct rule {
	int		r_type;		/* type of rule--see below */
	int		r_day;		/* day number of rule */
	int		r_week;		/* week number of rule */
	int		r_mon;		/* month number of rule */
	long		r_time;		/* transition time of rule */
};

#define	JULIAN_DAY		0	/* Jn - Julian day */
#define	DAY_OF_YEAR		1	/* n - day of year */
#define	MONTH_NTH_DAY_OF_WEEK	2	/* Mm.n.d - month, week, day of week */

/*
** Prototypes for static functions.
*/

static long		detzcode P((const char * codep));
static const char *	getzname P((const char * strp));
static const char *	getnum P((const char * strp, int * nump, int min,
				int max));
static const char *	getsecs P((const char * strp, long * secsp));
static const char *	getoffset P((const char * strp, long * offsetp));
static const char *	getrule P((const char * strp, struct rule * rulep));
static void		gmtload P((struct state * sp));
static void		gmtsub P((const time_t * timep, long offset,
				struct tm * tmp));
static void		localsub P((const time_t * timep, long offset,
				struct tm * tmp));
static void		normalize P((int * tensptr, int * unitsptr, int base));
static void		settzname P((void));
static time_t		time1 P((struct tm * tmp, void (* funcp)(),
				long offset));
static time_t		time2 P((struct tm *tmp, void (* funcp)(),
				long offset, int * okayp));
static void		timesub P((const time_t * timep, long offset,
				const struct state * sp, struct tm * tmp));
static int		tmcomp P((const struct tm * atmp,
				const struct tm * btmp));
static time_t		transtime P((time_t janfirst, int year,
				const struct rule * rulep, long offset));
static int		tzload P((const char * name, struct state * sp));
static int		tzparse P((const char * name, struct state * sp,
				int lastditch));

#ifdef ALL_STATE
static struct state *	lclptr;
static struct state *	gmtptr;
#endif /* defined ALL_STATE */

#ifndef ALL_STATE
static struct state	lclmem;
static struct state	gmtmem;
#define lclptr		(&lclmem)
#define gmtptr		(&gmtmem)
#endif /* State Farm */

static int		lcl_is_set;
static int		gmt_is_set;

char *			tzname[2] = {
	WILDABBR,
	WILDABBR
};

static long
detzcode(codep)
const char * const	codep;
{
	register long	result;
	register int	i;

	result = 0;
	for (i = 0; i < 4; ++i)
		result = (result << 8) | (codep[i] & 0xff);
	return result;
}

static void
settzname()
{
	register const struct state * const	sp = lclptr;
	register int				i;

	tzname[0] = WILDABBR;
	tzname[1] = WILDABBR;
#ifdef ALL_STATE
	if (sp == NULL) {
		tzname[0] = tzname[1] = GMT;
		return;
	}
#endif /* defined ALL_STATE */
	for (i = 0; i < sp->typecnt; ++i) {
		register const struct ttinfo * const	ttisp = &sp->ttis[i];

		tzname[ttisp->tt_isdst] =
			(char *) &sp->chars[ttisp->tt_abbrind];
#if 0
		if (ttisp->tt_isdst)
			_daylight = 1;
		if (i == 0 || !ttisp->tt_isdst)
			_timezone = -(ttisp->tt_gmtoff);
		if (i == 0 || ttisp->tt_isdst)
			_altzone = -(ttisp->tt_gmtoff);
#endif
	}
	/*
	** And to get the latest zone names into tzname. . .
	*/
	for (i = 0; i < sp->timecnt; ++i) {
		register const struct ttinfo * const	ttisp =
							&sp->ttis[sp->types[i]];

		tzname[ttisp->tt_isdst] =
			(char *) &sp->chars[ttisp->tt_abbrind];
	}
}

static char *
tzdir()
{
  static char dir[80]={0}, *cp;
/* patch 94.10.31  by T.Yasuda
  if (dir[0] == 0)
  {
*/
    if ((cp = getenv("TZDIR")))
    {
      strcpy(dir, cp);
    }
    else if ((cp = getenv("DJDIR")))
    {
      strcpy(dir, cp);
      strcat(dir, "/zoneinfo");
    }
    else
      strcpy(dir, "./");
/* patch 94.10.31  by T.Yasuda
  }
*/
  return dir;
}

static int
tzload(name, sp)
register const char *		name;
register struct state * const	sp;
{
	register const char *	p;
	register int		i;
	register int		fid;

	if (name == NULL && (name = TZDEFAULT) == NULL)
		return -1;
	{
		char		fullname[FILENAME_MAX + 1];

		if (name[0] == ':')
			++name;
		if (name[0] != '/') {
			if ((p = tzdir()) == NULL)
				return -1;
			if ((strlen(p) + strlen(name) + 1) >= sizeof fullname)
				return -1;
			(void) strcpy(fullname, p);
			(void) strcat(fullname, "/");
			(void) strcat(fullname, name);
			name = fullname;
		}
		if ((fid = open(name, OPEN_MODE)) == -1)
			return -1;
	}
	{
		register const struct tzhead *	tzhp;
		char				buf[sizeof *sp + sizeof *tzhp];
		int				ttisstdcnt;

		i = read(fid, buf, sizeof buf);
		if (close(fid) != 0 || i < sizeof *tzhp)
			return -1;
		tzhp = (struct tzhead *) buf;
		ttisstdcnt = (int) detzcode(tzhp->tzh_ttisstdcnt);
		sp->leapcnt = (int) detzcode(tzhp->tzh_leapcnt);
		sp->timecnt = (int) detzcode(tzhp->tzh_timecnt);
		sp->typecnt = (int) detzcode(tzhp->tzh_typecnt);
		sp->charcnt = (int) detzcode(tzhp->tzh_charcnt);
		if (sp->leapcnt < 0 || sp->leapcnt > TZ_MAX_LEAPS ||
			sp->typecnt <= 0 || sp->typecnt > TZ_MAX_TYPES ||
			sp->timecnt < 0 || sp->timecnt > TZ_MAX_TIMES ||
			sp->charcnt < 0 || sp->charcnt > TZ_MAX_CHARS ||
			(ttisstdcnt != sp->typecnt && ttisstdcnt != 0))
				return -1;
		if (i < sizeof *tzhp +
			sp->timecnt * (4 + sizeof (char)) +
			sp->typecnt * (4 + 2 * sizeof (char)) +
			sp->charcnt * sizeof (char) +
			sp->leapcnt * 2 * 4 +
			ttisstdcnt * sizeof (char))
				return -1;
		p = buf + sizeof *tzhp;
		for (i = 0; i < sp->timecnt; ++i) {
			sp->ats[i] = detzcode(p);
			p += 4;
		}
		for (i = 0; i < sp->timecnt; ++i) {
			sp->types[i] = (unsigned char) *p++;
			if (sp->types[i] >= sp->typecnt)
				return -1;
		}
		for (i = 0; i < sp->typecnt; ++i) {
			register struct ttinfo *	ttisp;

			ttisp = &sp->ttis[i];
			ttisp->tt_gmtoff = detzcode(p);
			p += 4;
			ttisp->tt_isdst = (unsigned char) *p++;
			if (ttisp->tt_isdst != 0 && ttisp->tt_isdst != 1)
				return -1;
			ttisp->tt_abbrind = (unsigned char) *p++;
			if (ttisp->tt_abbrind < 0 ||
				ttisp->tt_abbrind > sp->charcnt)
					return -1;
		}
		for (i = 0; i < sp->charcnt; ++i)
			sp->chars[i] = *p++;
		sp->chars[i] = '\0';	/* ensure '\0' at end */
		for (i = 0; i < sp->leapcnt; ++i) {
			register struct lsinfo *	lsisp;

			lsisp = &sp->lsis[i];
			lsisp->ls_trans = detzcode(p);
			p += 4;
			lsisp->ls_corr = detzcode(p);
			p += 4;
		}
		for (i = 0; i < sp->typecnt; ++i) {
			register struct ttinfo *	ttisp;

			ttisp = &sp->ttis[i];
			if (ttisstdcnt == 0)
				ttisp->tt_ttisstd = FALSE;
			else {
				ttisp->tt_ttisstd = *p++;
				if (ttisp->tt_ttisstd != TRUE &&
					ttisp->tt_ttisstd != FALSE)
						return -1;
			}
		}
	}
	return 0;
}

static const int	mon_lengths[2][MONSPERYEAR] = {
	{ 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 },
	{ 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 }
};

static const int	year_lengths[2] = {
	DAYSPERNYEAR, DAYSPERLYEAR
};

/*
** Given a pointer into a time zone string, scan until a character that is not
** a valid character in a zone name is found.  Return a pointer to that
** character.
*/

static const char *
getzname(strp)
register const char *	strp;
{
	register char	c;

	while ((c = *strp) != '\0' && !isdigit(c) && c != ',' && c != '-' &&
		c != '+')
			++strp;
	return strp;
}

/*
** Given a pointer into a time zone string, extract a number from that string.
** Check that the number is within a specified range; if it is not, return
** NULL.
** Otherwise, return a pointer to the first character not part of the number.
*/

static const char *
getnum(strp, nump, min, max)
register const char *	strp;
int * const		nump;
const int		min;
const int		max;
{
	register char	c;
	register int	num;

	if (strp == NULL || !isdigit(*strp))
		return NULL;
	num = 0;
	while ((c = *strp) != '\0' && isdigit(c)) {
		num = num * 10 + (c - '0');
		if (num > max)
			return NULL;	/* illegal value */
		++strp;
	}
	if (num < min)
		return NULL;		/* illegal value */
	*nump = num;
	return strp;
}

/*
** Given a pointer into a time zone string, extract a number of seconds,
** in hh[:mm[:ss]] form, from the string.
** If any error occurs, return NULL.
** Otherwise, return a pointer to the first character not part of the number
** of seconds.
*/

static const char *
getsecs(strp, secsp)
register const char *	strp;
long * const		secsp;
{
	int	num;

	strp = getnum(strp, &num, 0, HOURSPERDAY);
	if (strp == NULL)
		return NULL;
	*secsp = num * SECSPERHOUR;
	if (*strp == ':') {
		++strp;
		strp = getnum(strp, &num, 0, MINSPERHOUR - 1);
		if (strp == NULL)
			return NULL;
		*secsp += num * SECSPERMIN;
		if (*strp == ':') {
			++strp;
			strp = getnum(strp, &num, 0, SECSPERMIN - 1);
			if (strp == NULL)
				return NULL;
			*secsp += num;
		}
	}
	return strp;
}

/*
** Given a pointer into a time zone string, extract an offset, in
** [+-]hh[:mm[:ss]] form, from the string.
** If any error occurs, return NULL.
** Otherwise, return a pointer to the first character not part of the time.
*/

static const char *
getoffset(strp, offsetp)
register const char *	strp;
long * const		offsetp;
{
	register int	neg;

	if (*strp == '-') {
		neg = 1;
		++strp;
	} else if (isdigit(*strp) || *strp++ == '+')
		neg = 0;
	else	return NULL;		/* illegal offset */
	strp = getsecs(strp, offsetp);
	if (strp == NULL)
		return NULL;		/* illegal time */
	if (neg)
		*offsetp = -*offsetp;
	return strp;
}

/*
** Given a pointer into a time zone string, extract a rule in the form
** date[/time].  See POSIX section 8 for the format of "date" and "time".
** If a valid rule is not found, return NULL.
** Otherwise, return a pointer to the first character not part of the rule.
*/

static const char *
getrule(strp, rulep)
const char *			strp;
register struct rule * const	rulep;
{
	if (*strp == 'J') {
		/*
		** Julian day.
		*/
		rulep->r_type = JULIAN_DAY;
		++strp;
		strp = getnum(strp, &rulep->r_day, 1, DAYSPERNYEAR);
	} else if (*strp == 'M') {
		/*
		** Month, week, day.
		*/
		rulep->r_type = MONTH_NTH_DAY_OF_WEEK;
		++strp;
		strp = getnum(strp, &rulep->r_mon, 1, MONSPERYEAR);
		if (strp == NULL)
			return NULL;
		if (*strp++ != '.')
			return NULL;
		strp = getnum(strp, &rulep->r_week, 1, 5);
		if (strp == NULL)
			return NULL;
		if (*strp++ != '.')
			return NULL;
		strp = getnum(strp, &rulep->r_day, 0, DAYSPERWEEK - 1);
	} else if (isdigit(*strp)) {
		/*
		** Day of year.
		*/
		rulep->r_type = DAY_OF_YEAR;
		strp = getnum(strp, &rulep->r_day, 0, DAYSPERLYEAR - 1);
	} else	return NULL;		/* invalid format */
	if (strp == NULL)
		return NULL;
	if (*strp == '/') {
		/*
		** Time specified.
		*/
		++strp;
		strp = getsecs(strp, &rulep->r_time);
	} else	rulep->r_time = 2 * SECSPERHOUR;	/* default = 2:00:00 */
	return strp;
}

/*
** Given the Epoch-relative time of January 1, 00:00:00 GMT, in a year, the
** year, a rule, and the offset from GMT at the time that rule takes effect,
** calculate the Epoch-relative time that rule takes effect.
*/

static time_t
transtime(janfirst, year, rulep, offset)
const time_t				janfirst;
const int				year;
register const struct rule * const	rulep;
const long				offset;
{
  register int	leapyear;
  register time_t	value=0;
  register int	i;
  int		d, m1, yy0, yy1, yy2, dow;

  leapyear = isleap(year);
  switch (rulep->r_type) {

  case JULIAN_DAY:
    /*
     ** Jn - Julian day, 1 == January 1, 60 == March 1 even in leap
     ** years.
     ** In non-leap years, or if the day number is 59 or less, just
     ** add SECSPERDAY times the day number-1 to the time of
     ** January 1, midnight, to get the day.
     */
    value = janfirst + (rulep->r_day - 1) * SECSPERDAY;
    if (leapyear && rulep->r_day >= 60)
      value += SECSPERDAY;
    break;

  case DAY_OF_YEAR:
    /*
     ** n - day of year.
     ** Just add SECSPERDAY times the day number to the time of
     ** January 1, midnight, to get the day.
     */
    value = janfirst + rulep->r_day * SECSPERDAY;
    break;

  case MONTH_NTH_DAY_OF_WEEK:
    /*
     ** Mm.n.d - nth "dth day" of month m.
     */
    value = janfirst;
    for (i = 0; i < rulep->r_mon - 1; ++i)
      value += mon_lengths[leapyear][i] * SECSPERDAY;

    /*
     ** Use Zeller's Congruence to get day-of-week of first day of
     ** month.
     */
    m1 = (rulep->r_mon + 9) % 12 + 1;
    yy0 = (rulep->r_mon <= 2) ? (year - 1) : year;
    yy1 = yy0 / 100;
    yy2 = yy0 % 100;
    dow = ((26 * m1 - 2) / 10 +
	   1 + yy2 + yy2 / 4 + yy1 / 4 - 2 * yy1) % 7;
    if (dow < 0)
      dow += DAYSPERWEEK;

    /*
     ** "dow" is the day-of-week of the first day of the month.  Get
     ** the day-of-month (zero-origin) of the first "dow" day of the
     ** month.
     */
    d = rulep->r_day - dow;
    if (d < 0)
      d += DAYSPERWEEK;
    for (i = 1; i < rulep->r_week; ++i) {
      if (d + DAYSPERWEEK >=
	  mon_lengths[leapyear][rulep->r_mon - 1])
	break;
      d += DAYSPERWEEK;
    }

    /*
     ** "d" is the day-of-month (zero-origin) of the day we want.
     */
    value += d * SECSPERDAY;
    break;
  }

  /*
   ** "value" is the Epoch-relative time of 00:00:00 GMT on the day in
   ** question.  To get the Epoch-relative time of the specified local
   ** time on that day, add the transition time and the current offset
   ** from GMT.
   */
  return value + rulep->r_time + offset;
}

/*
** Given a POSIX section 8-style TZ string, fill in the rule tables as
** appropriate.
*/

static int
tzparse(name, sp, lastditch)
const char *			name;
register struct state * const	sp;
const int			lastditch;
{
  const char *			stdname;
  const char *			dstname=0;
  int				stdlen;
  int				dstlen;
  long				stdoffset;
  long				dstoffset;
  register time_t *		atp;
  register unsigned char *	typep;
  register char *			cp;
  register int			load_result;

  stdname = name;
  if (lastditch) {
    stdlen = strlen(name);	/* length of standard zone name */
    name += stdlen;
    if (stdlen >= sizeof sp->chars)
      stdlen = (sizeof sp->chars) - 1;
  } else {
    name = getzname(name);
    stdlen = name - stdname;
    if (stdlen < 3)
      return -1;
  }
  if (*name == '\0')
    return -1;
  else {
    name = getoffset(name, &stdoffset);
    if (name == NULL)
      return -1;
  }
  load_result = tzload(TZDEFRULES, sp);
  if (load_result != 0)
    sp->leapcnt = 0;		/* so, we're off a little */
  if (*name != '\0') {
    dstname = name;
    name = getzname(name);
    dstlen = name - dstname;	/* length of DST zone name */
    if (dstlen < 3)
      return -1;
    if (*name != '\0' && *name != ',' && *name != ';') {
      name = getoffset(name, &dstoffset);
      if (name == NULL)
	return -1;
    } else	dstoffset = stdoffset - SECSPERHOUR;
    if (*name == ',' || *name == ';') {
      struct rule	start;
      struct rule	end;
      register int	year;
      register time_t	janfirst;
      time_t		starttime;
      time_t		endtime;

      ++name;
      if ((name = getrule(name, &start)) == NULL)
	return -1;
      if (*name++ != ',')
	return -1;
      if ((name = getrule(name, &end)) == NULL)
	return -1;
      if (*name != '\0')
	return -1;
      sp->typecnt = 2;		/* standard time and DST */
      /*
       ** Two transitions per year, from EPOCH_YEAR to 2037.
       */
      sp->timecnt = 2 * (2037 - EPOCH_YEAR + 1);
      if (sp->timecnt > TZ_MAX_TIMES)
	return -1;
      sp->ttis[0].tt_gmtoff = -dstoffset;
      sp->ttis[0].tt_isdst = 1;
      sp->ttis[0].tt_abbrind = stdlen + 1;
      sp->ttis[1].tt_gmtoff = -stdoffset;
      sp->ttis[1].tt_isdst = 0;
      sp->ttis[1].tt_abbrind = 0;
      atp = sp->ats;
      typep = sp->types;
      janfirst = 0;
      for (year = EPOCH_YEAR; year <= 2037; ++year) {
	starttime = transtime(janfirst, year, &start,
			      stdoffset);
	endtime = transtime(janfirst, year, &end,
			    dstoffset);
	if (starttime > endtime) {
	  *atp++ = endtime;
	  *typep++ = 1;		/* DST ends */
	  *atp++ = starttime;
	  *typep++ = 0;		/* DST begins */
	} else {
	  *atp++ = starttime;
	  *typep++ = 0;		/* DST begins */
	  *atp++ = endtime;
	  *typep++ = 1;		/* DST ends */
	}
	janfirst +=
	  year_lengths[isleap(year)] * SECSPERDAY;
      }
    } else {
      int		sawstd;
      int		sawdst;
      long		stdfix;
      long		dstfix;
      long		oldfix;
      int		isdst;
      register int	i;

      if (*name != '\0')
	return -1;
      if (load_result != 0)
	return -1;
      /*
       ** Compute the difference between the real and
       ** prototype standard and summer time offsets
       ** from GMT, and put the real standard and summer
       ** time offsets into the rules in place of the
       ** prototype offsets.
       */
      sawstd = FALSE;
      sawdst = FALSE;
      stdfix = 0;
      dstfix = 0;
      for (i = 0; i < sp->typecnt; ++i) {
	if (sp->ttis[i].tt_isdst) {
	  oldfix = dstfix;
	  dstfix =
	    sp->ttis[i].tt_gmtoff + dstoffset;
	  if (sawdst && (oldfix != dstfix))
	    return -1;
	  sp->ttis[i].tt_gmtoff = -dstoffset;
	  sp->ttis[i].tt_abbrind = stdlen + 1;
	  sawdst = TRUE;
	} else {
	  oldfix = stdfix;
	  stdfix =
	    sp->ttis[i].tt_gmtoff + stdoffset;
	  if (sawstd && (oldfix != stdfix))
	    return -1;
	  sp->ttis[i].tt_gmtoff = -stdoffset;
	  sp->ttis[i].tt_abbrind = 0;
	  sawstd = TRUE;
	}
      }
      /*
       ** Make sure we have both standard and summer time.
       */
      if (!sawdst || !sawstd)
	return -1;
      /*
       ** Now correct the transition times by shifting
       ** them by the difference between the real and
       ** prototype offsets.  Note that this difference
       ** can be different in standard and summer time;
       ** the prototype probably has a 1-hour difference
       ** between standard and summer time, but a different
       ** difference can be specified in TZ.
       */
      isdst = FALSE;		/* we start in standard time */
      for (i = 0; i < sp->timecnt; ++i) {
	register const struct ttinfo *	ttisp;

	/*
	 ** If summer time is in effect, and the
	 ** transition time was not specified as
	 ** standard time, add the summer time
	 ** offset to the transition time;
	 ** otherwise, add the standard time offset
	 ** to the transition time.
	 */
	ttisp = &sp->ttis[sp->types[i]];
	sp->ats[i] +=
	  (isdst && !ttisp->tt_ttisstd) ?
	    dstfix : stdfix;
	isdst = ttisp->tt_isdst;
      }
    }
  } else {
    dstlen = 0;
    sp->typecnt = 1;		/* only standard time */
    sp->timecnt = 0;
    sp->ttis[0].tt_gmtoff = -stdoffset;
    sp->ttis[0].tt_isdst = 0;
    sp->ttis[0].tt_abbrind = 0;
  }
  sp->charcnt = stdlen + 1;
  if (dstlen != 0)
    sp->charcnt += dstlen + 1;
  if (sp->charcnt > sizeof sp->chars)
    return -1;
  cp = sp->chars;
  (void) strncpy(cp, stdname, stdlen);
  cp += stdlen;
  *cp++ = '\0';
  if (dstlen != 0) {
    (void) strncpy(cp, dstname, dstlen);
    *(cp + dstlen) = '\0';
  }
  return 0;
}

static void
gmtload(sp)
struct state * const	sp;
{
	if (tzload(GMT, sp) != 0)
		(void) tzparse(GMT, sp, TRUE);
}

void
tzset()
{
  register const char *	name;
  void tzsetwall();

  name = getenv("TZ");
  if (name == NULL) {
    tzsetwall();
    return;
  }
  lcl_is_set = TRUE;
#ifdef ALL_STATE
  if (lclptr == NULL) {
    lclptr = (struct state *) malloc(sizeof *lclptr);
    if (lclptr == NULL) {
      settzname();		/* all we can do */
      return;
    }
  }
#endif /* defined ALL_STATE */
  if (*name == '\0') {
    /*
     ** User wants it fast rather than right.
     */
    lclptr->leapcnt = 0;	/* so, we're off a little */
    lclptr->timecnt = 0;
    lclptr->ttis[0].tt_gmtoff = 0;
    lclptr->ttis[0].tt_abbrind = 0;
    (void) strcpy(lclptr->chars, GMT);
  } else if (tzload(name, lclptr) != 0)
    if (name[0] == ':' || tzparse(name, lclptr, FALSE) != 0)
      (void) gmtload(lclptr);
  settzname();
}

void
tzsetwall()
{
	lcl_is_set = TRUE;
#ifdef ALL_STATE
	if (lclptr == NULL) {
		lclptr = (struct state *) malloc(sizeof *lclptr);
		if (lclptr == NULL) {
			settzname();	/* all we can do */
			return;
		}
	}
#endif /* defined ALL_STATE */
	if (tzload((char *) NULL, lclptr) != 0)
		gmtload(lclptr);
	settzname();
}

/*
** The easy way to behave "as if no library function calls" localtime
** is to not call it--so we drop its guts into "localsub", which can be
** freely called.  (And no, the PANS doesn't require the above behavior--
** but it *is* desirable.)
**
** The unused offset argument is for the benefit of mktime variants.
*/

/*ARGSUSED*/
static void
localsub(timep, offset, tmp)
const time_t * const	timep;
const long		offset;
struct tm * const	tmp;
{
	register const struct state *	sp;
	register const struct ttinfo *	ttisp;
	register int			i;
	const time_t			t = *timep;

	if (!lcl_is_set)
		tzset();
	sp = lclptr;
#ifdef ALL_STATE
	if (sp == NULL) {
		gmtsub(timep, offset, tmp);
		return;
	}
#endif /* defined ALL_STATE */
	if (sp->timecnt == 0 || t < sp->ats[0]) {
		i = 0;
		while (sp->ttis[i].tt_isdst)
			if (++i >= sp->typecnt) {
				i = 0;
				break;
			}
	} else {
		for (i = 1; i < sp->timecnt; ++i)
			if (t < sp->ats[i])
				break;
		i = sp->types[i - 1];
	}
	ttisp = &sp->ttis[i];
	/*
	** To get (wrong) behavior that's compatible with System V Release 2.0
	** you'd replace the statement below with
	**	t += ttisp->tt_gmtoff;
	**	timesub(&t, 0L, sp, tmp);
	*/
	timesub(&t, ttisp->tt_gmtoff, sp, tmp);
	tmp->tm_isdst = ttisp->tt_isdst;
	tzname[tmp->tm_isdst] = (char *) &sp->chars[ttisp->tt_abbrind];
	tmp->tm_zone = (char *)&sp->chars[ttisp->tt_abbrind];
}

struct tm *
localtime(timep)
const time_t * const	timep;
{
	static struct tm	tm;

	localsub(timep, 0L, &tm);
	return &tm;
}

/*
** gmtsub is to gmtime as localsub is to localtime.
*/

static void
gmtsub(timep, offset, tmp)
const time_t * const	timep;
const long		offset;
struct tm * const	tmp;
{
	if (!gmt_is_set) {
		gmt_is_set = TRUE;
#ifdef ALL_STATE
		gmtptr = (struct state *) malloc(sizeof *gmtptr);
		if (gmtptr != NULL)
#endif /* defined ALL_STATE */
			gmtload(gmtptr);
	}
	timesub(timep, offset, gmtptr, tmp);
	/*
	** Could get fancy here and deliver something such as
	** "GMT+xxxx" or "GMT-xxxx" if offset is non-zero,
	** but this is no time for a treasure hunt.
	*/
	if (offset != 0)
		tmp->tm_zone = WILDABBR;
	else {
#ifdef ALL_STATE
		if (gmtptr == NULL)
			tmp->TM_ZONE = GMT;
		else	tmp->TM_ZONE = gmtptr->chars;
#endif /* defined ALL_STATE */
#ifndef ALL_STATE
		tmp->tm_zone = gmtptr->chars;
#endif /* State Farm */
	}
}

struct tm *
gmtime(timep)
const time_t * const	timep;
{
	static struct tm	tm;

	gmtsub(timep, 0L, &tm);
	return &tm;
}

static void
timesub(timep, offset, sp, tmp)
const time_t * const			timep;
const long				offset;
register const struct state * const	sp;
register struct tm * const		tmp;
{
	register const struct lsinfo *	lp;
	register long			days;
	register long			rem;
	register int			y;
	register int			yleap;
	register const int *		ip;
	register long			corr;
	register int			hit;
	register int			i;

	corr = 0;
	hit = FALSE;
#ifdef ALL_STATE
	i = (sp == NULL) ? 0 : sp->leapcnt;
#endif /* defined ALL_STATE */
#ifndef ALL_STATE
	i = sp->leapcnt;
#endif /* State Farm */
	while (--i >= 0) {
		lp = &sp->lsis[i];
		if (*timep >= lp->ls_trans) {
			if (*timep == lp->ls_trans)
				hit = ((i == 0 && lp->ls_corr > 0) ||
					lp->ls_corr > sp->lsis[i - 1].ls_corr);
			corr = lp->ls_corr;
			break;
		}
	}
	days = *timep / SECSPERDAY;
	rem = *timep % SECSPERDAY;
#ifdef mc68k
	if (*timep == 0x80000000) {
		/*
		** A 3B1 muffs the division on the most negative number.
		*/
		days = -24855;
		rem = -11648;
	}
#endif /* mc68k */
	rem += (offset - corr);
	while (rem < 0) {
		rem += SECSPERDAY;
		--days;
	}
	while (rem >= SECSPERDAY) {
		rem -= SECSPERDAY;
		++days;
	}
	tmp->tm_hour = (int) (rem / SECSPERHOUR);
	rem = rem % SECSPERHOUR;
	tmp->tm_min = (int) (rem / SECSPERMIN);
	tmp->tm_sec = (int) (rem % SECSPERMIN);
	if (hit)
		/*
		** A positive leap second requires a special
		** representation.  This uses "... ??:59:60".
		*/
		++(tmp->tm_sec);
	tmp->tm_wday = (int) ((EPOCH_WDAY + days) % DAYSPERWEEK);
	if (tmp->tm_wday < 0)
		tmp->tm_wday += DAYSPERWEEK;
	y = EPOCH_YEAR;
	if (days >= 0)
		for ( ; ; ) {
			yleap = isleap(y);
			if (days < (long) year_lengths[yleap])
				break;
			++y;
			days = days - (long) year_lengths[yleap];
		}
	else do {
		--y;
		yleap = isleap(y);
		days = days + (long) year_lengths[yleap];
	} while (days < 0);
	tmp->tm_year = y - TM_YEAR_BASE;
	tmp->tm_yday = (int) days;
	ip = mon_lengths[yleap];
	for (tmp->tm_mon = 0; days >= (long) ip[tmp->tm_mon]; ++(tmp->tm_mon))
		days = days - (long) ip[tmp->tm_mon];
	tmp->tm_mday = (int) (days + 1);
	tmp->tm_isdst = 0;
	tmp->tm_gmtoff = offset;
}

/*
** A la X3J11
*/

char *
asctime(timeptr)
register const struct tm *	timeptr;
{
	static const char	wday_name[DAYSPERWEEK][3] = {
		"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"
	};
	static const char	mon_name[MONSPERYEAR][3] = {
		"Jan", "Feb", "Mar", "Apr", "May", "Jun",
		"Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
	};
	static char	result[26];

	(void) sprintf(result, "%.3s %.3s%3d %02d:%02d:%02d %d\n",
		wday_name[timeptr->tm_wday],
		mon_name[timeptr->tm_mon],
		timeptr->tm_mday, timeptr->tm_hour,
		timeptr->tm_min, timeptr->tm_sec,
		TM_YEAR_BASE + timeptr->tm_year);
	return result;
}

char *
ctime(timep)
const time_t * const	timep;
{
	return asctime(localtime(timep));
}

/*
** Adapted from code provided by Robert Elz, who writes:
**	The "best" way to do mktime I think is based on an idea of Bob
**	Kridle's (so its said...) from a long time ago. (mtxinu!kridle now).
**	It does a binary search of the time_t space.  Since time_t's are
**	just 32 bits, its a max of 32 iterations (even at 64 bits it
**	would still be very reasonable).
*/

#ifndef WRONG
#define WRONG	(-1)
#endif /* !defined WRONG */

static void
normalize(tensptr, unitsptr, base)
int * const	tensptr;
int * const	unitsptr;
const int	base;
{
	if (*unitsptr >= base) {
		*tensptr += *unitsptr / base;
		*unitsptr %= base;
	} else if (*unitsptr < 0) {
		--*tensptr;
		*unitsptr += base;
		if (*unitsptr < 0) {
			*tensptr -= 1 + (-*unitsptr) / base;
			*unitsptr = base - (-*unitsptr) % base;
		}
	}
}

static int
tmcomp(atmp, btmp)
register const struct tm * const atmp;
register const struct tm * const btmp;
{
	register int	result;

	if ((result = (atmp->tm_year - btmp->tm_year)) == 0 &&
		(result = (atmp->tm_mon - btmp->tm_mon)) == 0 &&
		(result = (atmp->tm_mday - btmp->tm_mday)) == 0 &&
		(result = (atmp->tm_hour - btmp->tm_hour)) == 0 &&
		(result = (atmp->tm_min - btmp->tm_min)) == 0)
			result = atmp->tm_sec - btmp->tm_sec;
	return result;
}

static time_t
time2(tmp, funcp, offset, okayp)
struct tm * const	tmp;
void (* const		funcp)();
const long		offset;
int * const		okayp;
{
	register const struct state *	sp;
	register int			dir;
	register int			bits;
	register int			i, j ;
	register int			saved_seconds;
	time_t				newt;
	time_t				t;
	struct tm			yourtm, mytm;

	*okayp = FALSE;
	yourtm = *tmp;
	if (yourtm.tm_sec >= SECSPERMIN + 2 || yourtm.tm_sec < 0)
		normalize(&yourtm.tm_min, &yourtm.tm_sec, SECSPERMIN);
	normalize(&yourtm.tm_hour, &yourtm.tm_min, MINSPERHOUR);
	normalize(&yourtm.tm_mday, &yourtm.tm_hour, HOURSPERDAY);
	normalize(&yourtm.tm_year, &yourtm.tm_mon, MONSPERYEAR);
	while (yourtm.tm_mday <= 0) {
		--yourtm.tm_year;
		yourtm.tm_mday +=
			year_lengths[isleap(yourtm.tm_year + TM_YEAR_BASE)];
	}
	for ( ; ; ) {
		i = mon_lengths[isleap(yourtm.tm_year +
			TM_YEAR_BASE)][yourtm.tm_mon];
		if (yourtm.tm_mday <= i)
			break;
		yourtm.tm_mday -= i;
		if (++yourtm.tm_mon >= MONSPERYEAR) {
			yourtm.tm_mon = 0;
			++yourtm.tm_year;
		}
	}
	saved_seconds = yourtm.tm_sec;
	yourtm.tm_sec = 0;
	/*
	** Calculate the number of magnitude bits in a time_t
	** (this works regardless of whether time_t is
	** signed or unsigned, though lint complains if unsigned).
	*/
	for (bits = 0, t = 1; t > 0; ++bits, t <<= 1)
		;
	/*
	** If time_t is signed, then 0 is the median value,
	** if time_t is unsigned, then 1 << bits is median.
	*/
	t = (time_t) 1 << bits;
	for ( ; ; ) {
		(*funcp)(&t, offset, &mytm);
		dir = tmcomp(&mytm, &yourtm);
		if (dir != 0) {
			if (bits-- < 0)
				return WRONG;
			if (bits < 0)
				--t;
			else if (dir > 0)
				t -= (time_t) 1 << bits;
			else	t += (time_t) 1 << bits;
			continue;
		}
		if (yourtm.tm_isdst < 0 || mytm.tm_isdst == yourtm.tm_isdst)
			break;
		/*
		** Right time, wrong type.
		** Hunt for right time, right type.
		** It's okay to guess wrong since the guess
		** gets checked.
		*/
		sp = (const struct state *)
			((funcp == localsub) ? lclptr : gmtptr);
#ifdef ALL_STATE
		if (sp == NULL)
			return WRONG;
#endif /* defined ALL_STATE */
		for (i = 0; i < sp->typecnt; ++i) {
			if (sp->ttis[i].tt_isdst != yourtm.tm_isdst)
				continue;
			for (j = 0; j < sp->typecnt; ++j) {
				if (sp->ttis[j].tt_isdst == yourtm.tm_isdst)
					continue;
				newt = t + sp->ttis[j].tt_gmtoff -
					sp->ttis[i].tt_gmtoff;
				(*funcp)(&newt, offset, &mytm);
				if (tmcomp(&mytm, &yourtm) != 0)
					continue;
				if (mytm.tm_isdst != yourtm.tm_isdst)
					continue;
				/*
				** We have a match.
				*/
				t = newt;
				goto label;
			}
		}
		return WRONG;
	}
label:
	t += saved_seconds;
	(*funcp)(&t, offset, tmp);
	*okayp = TRUE;
	return t;
}

static time_t
time1(tmp, funcp, offset)
struct tm * const	tmp;
void (* const		funcp)();
const long		offset;
{
	register time_t			t;
	register const struct state *	sp;
	register int			samei, otheri;
	int				okay;

	if (tmp->tm_isdst > 1)
		tmp->tm_isdst = 1;
	t = time2(tmp, funcp, offset, &okay);
	if (okay || tmp->tm_isdst < 0)
		return t;
	/*
	** We're supposed to assume that somebody took a time of one type
	** and did some math on it that yielded a "struct tm" that's bad.
	** We try to divine the type they started from and adjust to the
	** type they need.
	*/
	sp = (const struct state *) ((funcp == localsub) ? lclptr : gmtptr);
#ifdef ALL_STATE
	if (sp == NULL)
		return WRONG;
#endif /* defined ALL_STATE */
	for (samei = 0; samei < sp->typecnt; ++samei) {
		if (sp->ttis[samei].tt_isdst != tmp->tm_isdst)
			continue;
		for (otheri = 0; otheri < sp->typecnt; ++otheri) {
			if (sp->ttis[otheri].tt_isdst == tmp->tm_isdst)
				continue;
			tmp->tm_sec += sp->ttis[otheri].tt_gmtoff -
					sp->ttis[samei].tt_gmtoff;
			tmp->tm_isdst = !tmp->tm_isdst;
			t = time2(tmp, funcp, offset, &okay);
			if (okay)
				return t;
			tmp->tm_sec -= sp->ttis[otheri].tt_gmtoff -
					sp->ttis[samei].tt_gmtoff;
			tmp->tm_isdst = !tmp->tm_isdst;
		}
	}
	return WRONG;
}

time_t
mktime(tmp)
const struct tm * tmp;
{
	return time1((struct tm *)tmp, localsub, 0L);
}

/*
 * ================================================================
 * JCTYPE.C
 * ================================================================
 */
/* This file may have been modified by DJ Delorie (Jan 1991).  If so,
** these modifications are Coyright (C) 1991 DJ Delorie, 24 Kirsten Ave,
** Rochester NH, 03867-2954, USA.
*/

/*
 * Copyright (c) 1989 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that: (1) source distributions retain this entire copyright
 * notice and comment, and (2) distributions including binaries display
 * the following acknowledgement:  ``This product includes software
 * developed by the University of California, Berkeley and its contributors''
 * in the documentation or other materials provided with the distribution
 * and in all advertising materials mentioning features or use of this
 * software. Neither the name of the University nor the names of its
 * contributors may be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*  Modified for Shift-JIS Code by Y.Shibata(FATMAN)  1992 Jun 6th  */

char _jctype_[1 + 256] = {
	0,
/*  0x00 - 0x1F  */
	0,	0,	0,	0,	0,	0,	0,	0,
	0,	0,	0,	0,	0,	0,	0,	0,
	0,	0,	0,	0,	0,	0,	0,	0,
	0,	0,	0,	0,	0,	0,	0,	0,
/*  0x20 - 0x3F  */
	0,	0,	0,	0,	0,	0,	0,	0,
	0,	0,	0,	0,	0,	0,	0,	0,
	0,	0,	0,	0,	0,	0,	0,	0,
	0,	0,	0,	0,	0,	0,	0,	0,
/*  0x40 - 0x5F  */
	_KS,	_KS,	_KS,	_KS,	_KS,	_KS,	_KS,	_KS,
	_KS,	_KS,	_KS,	_KS,	_KS,	_KS,	_KS,	_KS,
	_KS,	_KS,	_KS,	_KS,	_KS,	_KS,	_KS,	_KS,
	_KS,	_KS,	_KS,	_KS,	_KS,	_KS,	_KS,	_KS,
/*  0x60 - 0x7F  */
	_KS,	_KS,	_KS,	_KS,	_KS,	_KS,	_KS,	_KS,
	_KS,	_KS,	_KS,	_KS,	_KS,	_KS,	_KS,	_KS,
	_KS,	_KS,	_KS,	_KS,	_KS,	_KS,	_KS,	_KS,
	_KS,	_KS,	_KS,	_KS,	_KS,	_KS,	_KS,	0,
/*  0x80 - 0x9F  */
	_KS,	_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,
	_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,
	_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,
	_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,
/*  0xA0 - 0xBF  */
	_KS,	_KP|_KS,_KP|_KS,_KP|_KS,_KP|_KS,_KP|_KS,_KK|_KS,_KK|_KS,
	_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,
	_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,
	_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,
/*  0xC0 - 0xDF  */
	_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,
	_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,
	_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,
	_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,_KK|_KS,
/*  0xE0 - 0xFF  */
	_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,
	_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,
	_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,
	_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,_KF|_KS,0,	0,	0
};


/* 
 * ================================================================
 * dpmi					VMULE 0000xxxx
 *
 * This Section copy from DJGpp1.12(maint1) libsrc-'dpmi.c'.
 * modifyed DPMI Vector(31h -> vdpmi)
 *
 * Now support function is ax = 0x500 (get memory info.) onry One.
 * Other function for future....????( please yourself)
 * ================================================================
 */
int _go32_dpmi_allocate_dos_memory(_go32_dpmi_seginfo *info){
  r.x.ax = 0x0100;
  r.x.bx = info->size;
  int86(vdpmi, &r, &r);
  if(r.x.flags & 1){
    info->size = r.x.bx;
    return r.x.ax;
  }
  else{
    info->rm_segment = r.x.ax;
    info->rm_offset = 0;
    info->pm_selector = r.x.dx;
    info->pm_offset = 0;
    return 0;
  }
}

int _go32_dpmi_free_dos_memory(_go32_dpmi_seginfo *info){
  r.x.ax = 0x0101;
  r.x.dx = info->pm_selector;
  int86(vdpmi, &r, &r);
  return (r.x.flags & 1)? r.x.ax: 0;
}

int _go32_dpmi_resize_dos_memory(_go32_dpmi_seginfo *info){
  r.x.ax = 0x0102;
  r.x.bx = info->size;
  r.x.dx = info->pm_selector;
  int86(vdpmi, &r, &r);
  if (r.x.flags & 1){
    info->size = r.x.bx;
    return r.x.ax;
  }
  else
    return 0;
}

int _go32_dpmi_get_real_mode_interrupt_vector(int vector, _go32_dpmi_seginfo *info){
  r.x.ax = 0x0200;
  r.h.bl = vector;
  int86(vdpmi, &r, &r);
  info->rm_segment = r.x.cx;
  info->rm_offset = r.x.dx;
  return 0;
}

int _go32_dpmi_set_real_mode_interrupt_vector(int vector, _go32_dpmi_seginfo *info){
  r.x.ax = 0x0201;
  r.h.bl = vector;
  r.x.cx = info->rm_segment;
  r.x.dx = info->rm_offset;
  int86(vdpmi, &r, &r);
  return 0;
}

int _go32_dpmi_get_protected_mode_interrupt_vector(int vector, _go32_dpmi_seginfo *info){
  r.x.ax = 0x0204;
  r.h.bl = vector;
  int86(vdpmi, &r, &r);
  info->pm_selector = r.x.cx;
  info->pm_offset = r.x.dx;
  return 0;
}

int _go32_dpmi_set_protected_mode_interrupt_vector(int vector, _go32_dpmi_seginfo *info){
  r.x.ax = 0x0205;
  r.h.bl = vector;
  r.x.cx = info->pm_selector;
  r.x.dx = info->pm_offset;
  int86(vdpmi, &r, &r);
  return (r.x.flags & 1)? r.x.ax: 0;
}

/* In real DPMI, we enter with only CS known, and SS on a locked 4K stack which
   is *NOT* our SS.  We must set up everthing, including a stack swap, then
   restore it the way we found it.   C. Sandmann 4-93 */

static unsigned char wrapper_intcommon[] = {
  0x1e,					/* push    ds                  */
  0x06,					/* push    es                  */
  0x0f, 0xa0,				/* push    fs                  */
  0x0f, 0xa8,				/* push    gs                  */
  0x60,					/* pusha                       */
  0x66, 0xb8, 0x34, 0x12,		/* mov     ax,0x1234           */
  0x8e, 0xd8,				/* mov     ds,ax               */
  0x8e, 0xc0,				/* mov     es,ax               */
  0x8e, 0xe0,				/* mov     fs,ax               */
  0x8e, 0xe8,				/* mov     gs,ax               */
  0xbb, 0x00, 0x00, 0x00, 0x00, 	/* mov     ebx,_local_stack    */
  0xfc,					/* cld                         */
  0x89, 0xe1,				/* mov     ecx,esp             */
  0x8c, 0xd2,				/* mov     dx,ss               */
  0x8e, 0xd0,				/* mov     ss,ax               */
  0x89, 0xdc,				/* mov     esp,ebx             */
  0x52,					/* push    edx                 */
  0x51,					/* push    ecx                 */
  0xe8, 0x00, 0x00, 0x00, 0x00, 	/* call    _rmih               */
  0x58,					/* pop     eax                 */
  0x5b,					/* pop     ebx                 */
  0x8e, 0xd3,				/* mov     ss,bx               */
  0x89, 0xc4,				/* mov     esp,eax             */
  0x61,					/* popa                        */
  0x0f, 0xa9,				/* pop     gs                  */
  0x0f, 0xa1,				/* pop     fs                  */
  0x07,					/* pop     es                  */
  0x1f					/* pop     ds                  */
};

static unsigned char wrapper_intiret[] = {
  0xcf					/* iret                        */
};

static unsigned char wrapper_intchain[] = {
  0x2e, 0xff, 0x2d, 0x00, 0x00, 0x00, 0x00, 	/* jmp     cs:[_old_int+39]    */
  0xcf,						/* iret                        */
  0x78, 0x56, 0x34, 0x12,
  0xcd, 0xab
};

/* _interrupt_stack_size can be changed globally before calling this routine if
   needed.  Don't change it between calls or you will mess up the malloc chain ! */

unsigned _interrupt_stack_size = 32256;

int _go32_dpmi_chain_protected_mode_interrupt_vector(int vector, _go32_dpmi_seginfo *info)
{
  char *mystack;
  unsigned char *wrapper = (unsigned char *)malloc(sizeof(wrapper_intcommon) + sizeof(wrapper_intchain));
  if (wrapper == 0)
    return 0x8015;
  mystack = (char *)malloc(_interrupt_stack_size);
  if (mystack == 0)
    return 0x8015;

  r.x.ax = 0x0204;
  r.h.bl = vector;
  int86(vdpmi, &r, &r);

  memcpy(wrapper, wrapper_intcommon, sizeof(wrapper_intcommon));
  memcpy(wrapper+sizeof(wrapper_intcommon), wrapper_intchain, sizeof(wrapper_intchain));
  *(short *)(wrapper+9) = _go32_my_ds();
  *(long *)(wrapper+20) = (int)mystack + _interrupt_stack_size;
  *(long *)(wrapper+36) = info->pm_offset - (int)wrapper - 40;
  *(long *)(wrapper+sizeof(wrapper_intcommon)+3) = (long)wrapper+sizeof(wrapper_intcommon)+8;
  *(long *)(wrapper+sizeof(wrapper_intcommon)+8) = r.x.dx;
  *(short *)(wrapper+sizeof(wrapper_intcommon)+12) = r.x.cx;

  r.x.ax = 0x0205;
  r.h.bl = vector;
  r.x.cx = _go32_my_cs();
  r.x.dx = (int)wrapper;
  int86(vdpmi, &r, &r);
  return 0;
}

int _go32_dpmi_allocate_iret_wrapper(_go32_dpmi_seginfo *info)
{
  char *mystack;
  unsigned char *wrapper = (unsigned char *)malloc(sizeof(wrapper_intcommon) + sizeof(wrapper_intiret));
  if (wrapper == 0)
    return 0x8015;
  mystack = (char *)malloc(_interrupt_stack_size);
  if (mystack == 0)
    return 0x8015;

  memcpy(wrapper, wrapper_intcommon, sizeof(wrapper_intcommon));
  memcpy(wrapper+sizeof(wrapper_intcommon), wrapper_intiret, sizeof(wrapper_intiret));
  *(short *)(wrapper+9) = _go32_my_ds();
  *(long *)(wrapper+20) = (int)mystack + _interrupt_stack_size;
  *(long *)(wrapper+36) = info->pm_offset - (int)wrapper - 40;

  info->pm_offset = (int)wrapper;
  return 0;
}

int _go32_dpmi_free_iret_wrapper(_go32_dpmi_seginfo *info)
{
  char *mystack;
  char *wrapper = (char *)info->pm_offset;
  mystack = (char *)(*(long *)(wrapper+20) - _interrupt_stack_size);
  free(mystack);
  free(wrapper);
  return 0;
}

int _go32_dpmi_simulate_int(int vector, _go32_dpmi_registers *regs){
  if(vector == 0x21){
    r.x.ax = regs->d.eax;
    r.x.bx = regs->d.ebx;
    r.x.cx = regs->d.ecx;
    r.x.dx = regs->d.edx;
    r.x.si = regs->d.esi;
    r.x.di = regs->d.edi;
    r.x.flags = regs->x.flags;
    int86(0x21, &r, &r);
    regs->d.eax = r.x.ax;
    regs->d.ebx = r.x.bx;
    regs->d.ecx = r.x.cx;
    regs->d.edx = r.x.dx;
    regs->d.esi = r.x.si;
    regs->d.edi = r.x.di;
    regs->x.flags = r.x.flags;
  } else {
    r.h.bl = vector;
    r.h.bh = 0;
    r.x.cx = 0;
    r.x.di = (int)regs;
    if( (vector == 0x21) && (regs->x.ax == 0x4b00) ){
      r.x.ax = 0xff0a;
      int86(0x21, &r, &r);
    }else{
      r.x.ax = 0x0300;
      int86(vdpmi, &r, &r);
    }
  }
  return (r.x.flags & 1)? r.x.ax: 0;
}

int _go32_dpmi_simulate_fcall(_go32_dpmi_registers *regs)
{
  r.x.ax = 0x0301;
  r.h.bh = 0;
  r.x.cx = 0;
  r.x.di = (int)regs;
  int86(vdpmi, &r, &r);
  if (r.x.flags & 1)
    {
      return r.x.ax;
    }
  else
    {
      return 0;
    }
}

int _go32_dpmi_simulate_fcall_iret(_go32_dpmi_registers *regs)
{
  r.x.ax = 0x0302;
  r.h.bh = 0;
  r.x.cx = 0;
  r.x.di = (int)regs;
  int86(vdpmi, &r, &r);
  if (r.x.flags & 1)
    {
      return r.x.ax;
    }
  else
    {
      return 0;
    }
}

/* Bug here; this needs to be fixed like above with SS & CLD */

static unsigned char wrapper_common[] = {
  0x66, 0x06,			/* push    es                  */
  0x66, 0x1e,			/* push    ds                  */
  0x66, 0x06,			/* push    es                  */
  0x66, 0x1f,			/* pop     ds                  */
  0x56,				/* push    esi                 */
  0x57,				/* push    edi                 */
  0xe8, 0x00, 0x00, 0x00, 0x00,	/* call    _rmcb               */
  0x5f,				/* pop     edi                 */
  0x5e,				/* pop     esi                 */
  0x66, 0x1f,			/* pop     ds                  */
  0x66, 0x07,			/* pop     es                  */
  0xfc,				/* cld                         */
  0x66, 0x8b, 0x06,		/* mov     ax,[esi]            */
  0x66, 0x26, 0x89, 0x47, 0x2a,	/* mov     es:[edi+42],ax      */
  0x66, 0x8b, 0x46, 0x02,	/* mov     ax,[esi+2]          */
  0x66, 0x26, 0x89, 0x47, 0x2c,	/* mov     es:[edi+44],ax      */
};

static unsigned char wrapper_retf[] = {
  0x66, 0x26, 0x83, 0x47, 0x2e, 0x04,	/* add     es:[edi+46],0x4     */
  0xcf					/* iret                        */
};

static unsigned char wrapper_iret[] = {
  0x66, 0x8b, 0x46, 0x04,		/* mov     ax,[esi+4]          */
  0x66, 0x26, 0x89, 0x47, 0x20, 	/* mov     es:[edi+32],ax      */
  0x66, 0x26, 0x83, 0x47, 0x2e, 0x06,	/* add     es:[edi+46],0x6     */
  0xcf					/* iret                        */
};

int _go32_dpmi_allocate_real_mode_callback_retf(_go32_dpmi_seginfo *info, _go32_dpmi_registers *regs)
{
  unsigned char *wrapper = (unsigned char *)malloc(sizeof(wrapper_common) + sizeof(wrapper_retf));
  if (wrapper == 0)
    return 0x8015;

  memcpy(wrapper, wrapper_common, sizeof(wrapper_common));
  memcpy(wrapper+sizeof(wrapper_common), wrapper_retf, sizeof(wrapper_retf));
  *(long *)(wrapper+11) = info->pm_offset - (int)wrapper - 15;
  info->size = (int)wrapper;

  r.x.ax = 0x0303;
  r.x.si = (int)wrapper;
  r.x.di = (int)regs;
  s.ds = _go32_my_cs();
  s.es = _go32_my_ds();
  s.fs = 0;
  s.gs = 0;
  int86x(vdpmi, &r, &r, &s);
  if (r.x.flags & 1)
    {
      return r.x.ax;
    }
  else
    {
      info->rm_segment = r.x.cx;
      info->rm_offset = r.x.dx;
      return 0;
    }
}

int _go32_dpmi_allocate_real_mode_callback_iret(_go32_dpmi_seginfo *info, _go32_dpmi_registers *regs)
{
  unsigned char *wrapper = (unsigned char *)malloc(sizeof(wrapper_common) + sizeof(wrapper_iret));
  if (wrapper == 0)
    return 0x8015;

  memcpy(wrapper, wrapper_common, sizeof(wrapper_common));
  memcpy(wrapper+sizeof(wrapper_common), wrapper_iret, sizeof(wrapper_iret));
  *(long *)(wrapper+11) = info->pm_offset - (int)wrapper - 15;
  info->size = (int)wrapper;

  r.x.ax = 0x0303;
  r.x.si = (int)wrapper;
  r.x.di = (int)regs;
  s.ds = _go32_my_cs();
  s.es = _go32_my_ds();
  s.fs = 0;
  s.gs = 0;
  int86x(vdpmi, &r, &r, &s);
  if (r.x.flags & 1)
    {
      return r.x.ax;
    }
  else
    {
      info->rm_segment = r.x.cx;
      info->rm_offset = r.x.dx;
      return 0;
    }
}

int _go32_dpmi_free_real_mode_callback(_go32_dpmi_seginfo *info)
{
  free((char *)info->size);
  r.x.ax = 0x0304;
  r.x.cx = info->rm_segment;
  r.x.dx = info->rm_offset;
  int86(vdpmi, &r, &r);
  if (r.x.flags & 1)
    {
      return r.x.ax;
    }
  else
    {
      return 0;
    }
}

int _go32_dpmi_get_free_memory_information(_go32_dpmi_meminfo *info)
{
  r.x.ax = 0x0500;
  r.x.di = (int)info;
  int86(vdpmi, &r, &r);
  return 0;
}

u_long _go32_dpmi_remaining_physical_memory()
{
  _go32_dpmi_meminfo info;
  _go32_dpmi_get_free_memory_information(&info);
  if (info.available_physical_pages)
    return info.available_physical_pages * 4096;
  return info.available_memory;
}

u_long _go32_dpmi_remaining_virtual_memory()
{
  _go32_dpmi_meminfo info;
  _go32_dpmi_get_free_memory_information(&info);
  return info.available_memory;
}

/* 
 * ================================================================
 * go32win original				VMULE 32310004~
 * keyboard/mouse/event functions
 * ================================================================
 */

void go32win_install_ctrl_break_check(void *dst, void *src, int size){
  r.x.ax = 0x32310004;
  r.x.di = (int)dst;
  r.x.si = (int)src;
  r.x.cx = size;
  int86(VMULE, &r, &r);
}

void go32win_keyrawmode(int f){
  r.x.ax = 0x32310005;		/* Enable/Disable Mule Enhance mode */
  r.x.bx = f;
  int86(VMULE, &r, &r);
}

static int past_x;
static int past_y;
static unsigned long past_timestamp;

static void go32win_getmouse(FRAME_PTR *f,
			     Lisp_Object *bar_window,
			     enum scroll_bar_part *part,
			     Lisp_Object *x,
			     Lisp_Object *y,
			     unsigned long *time){
  *f = selected_frame;
  *part = 0;
  *bar_window = Qnil;
  XSET(*x, Lisp_Int, past_x);
  XSET(*y, Lisp_Int, past_y);
  *time = past_timestamp;
  selected_frame->mouse_moved = 0;
}


static void go32win_rawkeyread(struct input_event *buf){
  r.x.ax = 0x32310007;
  int86(VMULE, &r, &r);
  /* 
   * ----------------------------------------------------------------
   * <get input event>
   * ax: 1 == ascii key, 2 == function key, mouse(3 down, 4 up, 5 drag)
   * bx: key code or mouse button(1==L/2==R)
   * cx: bit0 == shift, bit1 == ctrl, bit2 == alt
   * dx: time
   * si: mouse x position
   * di:       y
   * ----------------------------------------------------------------
   */
  buf->code = r.x.bx & 0xff;
  buf->modifiers = ((r.x.cx & 1)? shift_modifier: 0) +
    ((r.x.cx & 2)? ctrl_modifier: 0) +
      ((r.x.cx & 4)? meta_modifier: 0);

  XSETFRAME (buf->frame_or_window, selected_frame);
  buf->timestamp = r.x.dx;
  switch( r.x.ax ){
  case 1:
    buf->kind = ascii_keystroke;
/*    buf->modifiers = 0;*/
    break;
  case 2:
    buf->kind = non_ascii_keystroke;
    buf->code |= 0xff00;
    break;
  case 3:
  case 4:
  case 5:
  case 6:
  case 7:
    buf->kind = mouse_click;
    buf->code = r.x.bx -1;
    switch( r.x.ax ){
    case 3:
      buf->modifiers += down_modifier; break;
    case 4:
      buf->modifiers += up_modifier; break;
    case 5:
      if( (past_x != r.x.si) || (past_y != r.x.di) ){
	past_x = r.x.si;
	past_y = r.x.di;
	past_timestamp = r.x.dx;
	selected_frame->mouse_moved = 1;
      }
      buf->kind = no_event;
      break;
    case 6:
      buf->modifiers += double_modifier; break;
    case 7:
      buf->modifiers += triple_modifier; break;
    }
    XSET(buf->x, Lisp_Int, r.x.si);
    XSET(buf->y, Lisp_Int, r.x.di);
    break;
  default:
    buf->kind = no_event;
  }
}

int go32win_keysns(){
  enum event_kind top;
  for(;;){
    top = (enum event_kind)retAX(0x32310006);
    if( top == ascii_keystroke ) return 1;
    if( top != no_event ){
      struct input_event tev;
      go32win_rawkeyread(&tev);
      if( tev.kind != no_event )
	kbd_buffer_store_event(&tev);
    }
    else
      break;
  }
  return 0;
}

int go32win_keyread(struct input_event *buf, int terms){
  int n = 0;
  if( go32win_keysns() )
    while( n < terms ){
      go32win_rawkeyread(buf++);
      n ++;
      if( ascii_keystroke != (enum event_kind)retAX(0x32310006) )
	break;
    }
  return n;
}

void go32win_keyclr(){
  retAX(0x3231000b);
}

/* 
 * ----------------------------------------------------------------
 * Lisp function(clipboard)
 * ----------------------------------------------------------------
 */
DEFUN ("go32win-put-clipboard", Fgo32win_put_clipboard, Sgo32win_put_clipboard, 2, 2, 0,
       "Clipboard PUT. for Windows 3.1(Go32win base).\n\
go32win-put-clipboard TYPE STRING\n\
TYPE is Windows 3.1 clipboard data type-name.(default <CF_TEXT>)\n\
STRING is clipboard data.")
  (Lisp_Object type, Lisp_Object data)
{
  unsigned char *type_name = 0;

  if( STRINGP(type) ){
    type_name = alloca(32);
    strncpy(type_name, XSTRING(type)->data, 31);
    type_name[31] = 0;
  }
  r.x.ax = 0x3231000c;
  r.x.bx = (unsigned)type_name;
  r.x.cx = STRINGP(data)? XSTRING(data)->size +1: 0U;
  r.x.si = STRINGP(data)? (unsigned)XSTRING(data)->data: 0U;
  int86(VMULE, &r, &r);	
  return data;
}

DEFUN ("go32win-get-clipboard", Fgo32win_get_clipboard, Sgo32win_get_clipboard, 0, 2, 0,
       "Clipboard GET. for Windows 3.1(Go32win base).\n\
go32win-get-clipboard [TYPE]\n\
TYPE is Windows 3.1 clipboard data type-name.(default NULL=<CF_TEXT>)")
  (Lisp_Object type, Lisp_Object bin)
{
  unsigned char *type_name = 0;
  Lisp_Object result = Qnil;

  if( STRINGP(type) ){
    type_name = alloca(32);
    strncpy(type_name, XSTRING(type)->data, 31);
    type_name[31] = 0;
  }
  r.x.ax = 0x3231000d;
  r.x.bx = (unsigned)type_name;
  r.x.cx = 0;
  r.x.di = 0;
  int86(VMULE, &r, &r);		/* 1st Call by Query Size */
  if( !(r.x.flags & 1) ){
    result = make_uninit_string(r.x.cx);
    if( STRINGP(result) && XSTRING(result)->size ){
      r.x.ax = 0x3231000d;
      r.x.bx = (unsigned)type_name;
      r.x.cx = XSTRING(result)->size;
      r.x.di = (unsigned)XSTRING(result)->data;
      int86(VMULE, &r, &r);
      if( r.x.flags & 1 ) result = Qnil;
      else if( EQ(bin, Qnil) )
	result = build_string(XSTRING(result)->data);
    }
  }
  return result;
}


DEFUN ("go32win-enum-clipboard", Fgo32win_enum_clipboard, Sgo32win_enum_clipboard, 0, 0, 0,
       "Enum clipboard data type. for Windows 3.1(Go32win base).")
   ()
{
  Lisp_Object argv[2];
  Lisp_Object result = Qnil;
  char *p, *t;

  r.x.ax = 0x3231000e;
  r.x.cx = 0x8000;
  r.x.di = (unsigned)(p = alloca(r.x.cx));
  int86(VMULE, &r, &r);
  while( *p ){
    for( t = p; *p && (*p != '\r') && (*p != '\n'); p++ );
    if( t != p ){
      if( *p ) *p++ = 0;
      argv[0] = build_string(t);
      argv[1] = Flist(1, argv);
      argv[0] = result;
      result = Fappend(2, argv);
    }
    else
      p++;
  }
  return result;
}


/* 
 * ================================================================
 * ctordtor
 * for Go32win New Version. Based lib/at98.a(src. ctordtor.c)
 * ================================================================
 */
typedef void (*func)(void);
extern func __go32_first_ctor[];
extern func __go32_last_ctor[];
extern func __go32_first_dtor[];
extern func __go32_last_dtor[];

static do_ctors()
{
  func *ctor;
  for (ctor=__go32_last_ctor-1; ctor >= __go32_first_ctor; ctor--)
    (*ctor)();
}

static do_dtors()
{
  func *dtor;
  for (dtor = __go32_first_dtor; dtor < __go32_last_dtor; dtor++)
    (*dtor)();
}

void *OldHeapEnd;

#if 0
/* 
 * ================================================================
 * Cuɂ DPMI pX^bNݒR[h̐؂!!
 *
 * Mule(_vς) ̃X^bNݒ́AGo32win ł __main() ̒ŁA
 * DOS ł _main() ̒ŁAꂼs܂B
 * ʏ́ÃR[hgpĂ(_stklen == 0 ̏ꍇ)͔
 * ܂񂪁AQNꍇɂ͂̕܂߂ăRpC
 * ĉB̏ꍇ load dump ̎s DPMI ł͍s܂B
 * ================================================================
 */
void _setstack(){};
#endif

void __main()
{
#ifdef LIGHT_STAT
  static void fixinode_init();
#endif
  static int main_called = 0;
  static void *keepptr = 0;
  static void *go32_sbrk;
  /* patch 95.12.10  by K.Fujii */
  extern void init_env_internal (void);

  init_env_internal ();
  /* end of patch */

  if (OldHeapEnd) {
    r.x.ax = 0x3000;
    r.x.bx = 0x474f3332;
    int86(0x21, &r, &r);
    if( r.x.cx != 0x57494e33 ){	/* WIN3 */
      abort ();
    }
    else {
      if( keepptr == 0 ){
	/* 
	 * Go32win  sbrk(0)lɂ́AX^bN̈mۂ̂߂̓ʂȍ׍HĂ܂B
	 * ܂AX^bÑZOgE~bg͏Ԃł͐ݒ肳Ă܂B
	 */
	void *volatile saveptr, *volatile localstack, *volatile r_esp;
	volatile unsigned PureCore, usestack, localstacksize, keepsize;
	volatile int callback = 0x32310010;
	vdpmi = VMULE;
/*      _go32_machine_type = 1; */	/* PC-AT DOSV */
/*	_go32_windows = 1; */
	_go32_info_block.run_mode = _GO32_RUN_MODE_DPMI;

	/* Check Stack Condition. See go32win/src/go32dll/amodule.cpp */
	{
	  PureCore = retAX(0x32310008);
	  go32_sbrk = sbrk(0);
	}
	if( (go32_sbrk == OldHeapEnd) &&
	    ((unsigned)go32_sbrk < PureCore) ){
	  asm volatile
	    ("	movl	%%esp, %%eax
		movl	%%eax, %0" : "=g" (r_esp):: "%eax");
	  usestack = PureCore -(unsigned)r_esp;
	  localstacksize = 4096 *DPMI_STACK_PRE_ALLOC;
	  {	/* allocate local stack and save stack data */
	    localstack = saveptr = malloc(usestack + localstacksize);
#define brkOverHead	(4096 *1)
	    if( ((unsigned)localstack + brkOverHead) < (unsigned)go32_sbrk ){
	      localstacksize = (unsigned)go32_sbrk - (unsigned)localstack -brkOverHead;
	      saveptr = realloc((void *)localstack, localstacksize);
	    }
	    if( localstack != saveptr ){
	      callback = 0x3231000a;
	      goto gw_abort;
	    }
	    saveptr = (void *)((char *)localstack + (localstacksize - usestack));
	    memcpy((void *)saveptr, (void *)r_esp, usestack);
	  }
	  /* stack switch to local */
	  asm volatile
	    ("	subl	%%eax, %%esp
		subl	%%eax, %%ebp"
	     :: "a" ((unsigned)r_esp - (unsigned)saveptr));

	  keepsize = 0x40000;
	  { /* allocate new stack */
	    keepptr = malloc(keepsize);
	    if( (unsigned)keepptr < PureCore ){
	      keepsize = PureCore - (unsigned)keepptr;
	      keepptr = realloc((void *)keepptr, keepsize);
	    }
	  }
	  /* restore stack data */
	  if( keepptr && (unsigned )keepptr < PureCore )
	    memcpy((void *)r_esp, (void *)saveptr, usestack);
	  else{
	    callback = 0x3231000a;
	    goto gw_abort;
	  }
	  /* stack restore */
	  asm volatile
	    ("	addl	%%eax, %%ebp
		addl	%%eax, %%esp"
	     :: "a" ((unsigned)r_esp - (unsigned)saveptr));
	  free((void *)localstack);
	  if( keepsize < retAX(0x32310009) )
	    callback = 0x3231000a;
	}
	else
	  callback = 0x3231000a;
      gw_abort:
	r.x.ax = callback;
	r.x.bx = (unsigned)go32_sbrk;
	r.x.cx = (unsigned)OldHeapEnd;
	r.x.dx = PureCore;
	r.x.si = (unsigned)keepptr;	/* ax 32310010 ł́AX^bNE~bgĐݒ(݁AX
					 * ^bNE~bg ebp WX^ɓ]pł悤ɖ
					 *  1 ݒ肳܂) */
	r.x.di = keepsize;
	int86(VMULE, &r, &r);
	mouse_position_hook = go32win_getmouse;
	go32win_keyrawmode(1);
/*      OldHeapEnd = 0; */
#ifdef LIGHT_STAT
	fixinode_init();
#endif
      }
    }
  }
  else{ /* DOS DPMI */
  pre_dump:
#if 0  /* 96.2.26  by K.Fujii */
    set_go32_machine_type();
    if ( (_go32_info_block.run_mode == _GO32_RUN_MODE_DPMI) && (keepptr == 0) ){
#ifdef BUILD_DPMI_STACK_DOS
      void *volatile ptr, *volatile gap, *volatile r_esp;
      volatile unsigned gapsize, usestack, keepsize;

      {
	go32_sbrk = sbrk(0);
      }
      if( !OldHeapEnd ) abort();
      asm volatile
	("	movl	%%esp, %%eax
		movl	%%eax, %0" : "=g" (r_esp):: "%eax");

      usestack = (unsigned)go32_sbrk -(unsigned)r_esp;
      gapsize = 4096 *DPMI_STACK_PRE_ALLOC;
      {
	gap = ptr = malloc(gapsize);
	if( ((unsigned)gap + brkOverHead) < (unsigned)OldHeapEnd ){
	  gapsize = (unsigned)OldHeapEnd - (unsigned)gap -brkOverHead;
	  ptr = realloc((void *)gap, gapsize);
	}
	if( gap != ptr ) abort();
      }

      keepsize = 0x10000;
      {	/* allocate temp stack page */
	keepptr = ptr = malloc(keepsize);
	if( go32_sbrk <= keepptr ) abort();
	keepsize = (unsigned)go32_sbrk - (unsigned)keepptr;
	ptr = realloc(keepptr, (unsigned)keepsize /2);
	if( ptr != keepptr ) abort();
	ptr = (void *)((unsigned)keepptr + ((unsigned)keepsize /2 - usestack));
	memcpy((void *)ptr, (void *)r_esp, usestack);
      }
      /* set temp stack */
      asm volatile
	("	movl	%0, %%eax
		subl	%%eax, %%esp
		subl	%%eax, %%ebp"
	 :: "g" ((unsigned)r_esp - (unsigned)ptr): "%eax");
					
      {	/* re allocate stack page */
	ptr = realloc(keepptr, (unsigned)keepsize);
	if( ptr != keepptr ) abort();
	ptr = (void *)((unsigned)keepptr + ((unsigned)keepsize /2 - usestack));
	memcpy((void *)r_esp, (void *)ptr, usestack);
      }
      /* restore stack */
      asm volatile
	("	movl	%0, %%eax
		addl	%%eax, %%esp
		addl	%%eax, %%ebp"
	 :: "g" ((unsigned)r_esp - (unsigned)ptr): "%eax");

      free(gap);
      OldHeapEnd = 0;
#else
      keepptr = &keepptr;
#endif /* BUILD_DPMI_STACK_DOS */
#ifdef LIGHT_STAT
      fixinode_init();
#endif
    }
#else /* 0 */
#ifdef LIGHT_STAT
    fixinode_init()
#endif
      ;
#endif
  }
  if (main_called)
    return;
  main_called = 1;

  do_ctors();
  atexit((func)do_dtors);
}

/* longjmp
 * ================================================================
 * DPMI z荞݃tOւ̑΍Ƃ CLI 폜Ă܂B
 * X^bNEZOg̃[h͕spȂ͂Ȃ̂ŁAʏł͈S
 * słƎv܂B
 * ================================================================
 */
asm(".text");			/* strip `cli' and `load ss' code */
asm("	.align	4,0x90
	.globl	_longjmp
_longjmp:
	movl	4(%esp),%edi");	/* jmp_buf */
asm("	movl	8(%esp),%eax");	/* eax */
asm("	movl	%eax,0(%edi)
	movl	24(%edi),%ebp
	movl	28(%edi),%esp
	pushl	32(%edi)");	/* eip */
asm("	movw	36(%edi),%ax
	movw	%ax,%es
	movw	38(%edi),%ax
	movw	%ax,%fs
	movw	40(%edi),%ax
	movw	%ax,%gs
	movl	0(%edi),%eax
	movl	4(%edi),%ebx
	movl	8(%edi),%ecx
	movl	12(%edi),%edx
	movl	16(%edi),%esi
	movl	20(%edi),%edi
	ret");


#ifdef abort
#undef abort
#endif

volatile void abort(void)
{
  static char msg[] = "Abort!\n";
  write(2,msg,sizeof(msg));
  asm volatile
    ("	push	%%eax
	movl	%0, %%eax
	int	$0x32" :: "i" (0x3231ffff));
  exit(1);
}

syms_of_go32win(){
  defsubr (&Sgo32win_put_clipboard);
  defsubr (&Sgo32win_get_clipboard);
  defsubr (&Sgo32win_enum_clipboard);
}

#ifdef LIGHT_STAT
/* 
 * ================================================================
 * inode 쐬̂߂̃[_vłėp\ŁAt@C
 * ̃I[vA[h蔲ďȗA獂
 * Ă邩Ȃ stat() 
 * ================================================================
 */
#ifdef stat
#undef stat
#endif

struct path_list {
  struct path_list *next;
  char	*path;
  int		inode, hash;
};
static struct path_list	*path_list[256];
static int		inode_count = 3;

#define POOL_SIZE 256
struct path_pool {
  struct path_pool *lnext;
  struct path_pool *fnext;
  int free;
  struct path_list path[POOL_SIZE];
};
static struct path_pool *p_pool;

struct path_list *pool_get()
{
  if( p_pool ){
    if( p_pool->free ) return &p_pool->path[--(p_pool->free)];
    else if( p_pool->fnext ){
      p_pool = p_pool->fnext;
      return pool_get();
    } else {
      struct path_pool *pp = p_pool;
      struct path_list *res;
      p_pool = 0;
      res = pool_get();
      if( p_pool ) p_pool->lnext = pp;
      return res;
    }
  } else {
    p_pool = malloc(sizeof(struct path_pool));
    if( p_pool ){
      p_pool->lnext = p_pool->fnext = 0;
      p_pool->free = POOL_SIZE;
      return pool_get();
    }
  }
  return 0;
}

#define NAME_SIZE (48 *POOL_SIZE)
struct name_pool {
  struct name_pool *lnext;
  struct name_pool *fnext;
  int free;
  char name[NAME_SIZE];
};
static struct name_pool *n_pool;

char *pool_strdup(const char *p, int len)
{
  if( n_pool ){
    if( (len +1) <= n_pool->free ){
      n_pool->free -= (len +1);
      return strcpy(&n_pool->name[n_pool->free], p);
    } else if( n_pool->fnext ){
      n_pool = n_pool->fnext;
      return pool_strdup(p, len);
    } else {
      struct name_pool *pp = n_pool;
      char *res;
      n_pool = 0;
      res = pool_strdup(p, len);
      if( n_pool ) n_pool->lnext = pp;
      return res;
    }
  } else {
    n_pool = malloc(sizeof(struct name_pool));
    if( n_pool ){
      n_pool->fnext = n_pool->lnext = 0;
      n_pool->free = NAME_SIZE;
      return pool_strdup(p, len);
    }
  }
  return 0;
}

static void fixinode_init()
{
  struct path_pool *pp;
  struct name_pool *np;
  int i;
	
  for( pp = p_pool; pp; pp = pp->lnext ){
    pp->free = POOL_SIZE;
    pp->fnext = pp->lnext;
  }
  for( np = n_pool; np; np = np->lnext ){
    np->free = NAME_SIZE;
    np->fnext = np->lnext;
  }
  for( i = 0; i < 256; i++ ) path_list[i] = 0;
  inode_count = 3;
}

static int fixinode(const char *path, struct mc_stat *buf)
{
  struct path_list	*path_ptr, *prev_ptr;
  const char			*p;
  int lhash, hash;

  /* Skip over device and leading '/' */
  if (path[1] == ':' && path[2] == '/') path += 3;

  /* We could probably use a better hash than this */
  p = path;
  lhash = 0;
  while (*p != '\0') lhash += *p++;
  hash = lhash & 0xff;

  /* Have we seen this string? */
  path_ptr = path_list[hash];
  prev_ptr = path_ptr;
  while (path_ptr){
    if( (lhash == path_ptr->hash) && strcmp(path, path_ptr->path) == 0) break;
    prev_ptr = path_ptr;
    path_ptr = path_ptr->next;
  }

  if (path_ptr)
    /* Same string, so same inode */
    buf->st_ino = path_ptr->inode;
  else{
    /* New string with same hash code */
    path_ptr = pool_get();
    if (path_ptr == 0) return -1;
    path_ptr->next = 0;
    path_ptr->hash = lhash;
    path_ptr->path = pool_strdup(path, (int)(p - path));
    if (path_ptr->path == 0) return -1;
    path_ptr->inode = inode_count;
    if (prev_ptr)
      prev_ptr->next = path_ptr;
    else
      path_list[hash] = path_ptr;
    buf->st_ino = inode_count;
    inode_count++;
  }
  return 0;
}

int stat(const char *path, struct mc_stat *buf)
{
  char	p[256];
  int		status;

  /* Normalize the path */
  _fixpath(path, p);

  /* Check for root path */
  if( strcmp(p, "/") == 0 || strcmp(p+1, ":/") == 0 ){
    /* Handle root path as special case, stat_assist doesn't like
       the root directory. */
    if (p[1] == ':'){
      if (p[0] >= 'a' && p[0] <= 'z')
	buf->st_dev = p[0] - 'a';
      else
	buf->st_dev = p[0] - 'A';
    }
    else
      buf->st_dev = -1;	/* No device? */
    buf->st_ino = 2;
    buf->st_mode = S_IFDIR | S_IREAD | S_IWRITE | S_IEXEC;
    buf->st_nlink = 1;
    buf->st_uid = getuid();
    buf->st_gid = getgid();
    buf->st_rdev = buf->st_dev;
    buf->st_size = 0;
    buf->st_atime = 0;
    buf->st_mtime = 0;
    buf->st_ctime = 0;
    buf->st_blksize = 4096;
    status = 0;
  } else {
    /* 
     * status = stat_assist(p, buf);
     *
     * t@C̃I[vAwb_[hɂ锻ȗBɃt@C𒲂ׂă[
     * hݒ肵ADOSs`̓t@Cgq(com, exe, bat)𒲂ׂĐݒ肷B
     */

    union REGS regs;
    regs.x.ax = 0xff06;
    regs.x.bx = (unsigned)p;
    regs.x.cx = (unsigned)buf;
    intdos(&regs, &regs);
    status = regs.x.cflag;

    buf->st_dev = buf->st_rdev;
    buf->st_uid = getuid();
    buf->st_gid = getgid();

    if( !status ){
      int	atr;

      status = fixinode(p, buf);

      regs.x.ax = 0x4300;
      regs.x.cx = 0;
      regs.x.dx = (unsigned)p;
      intdos(&regs, &regs);
      atr = regs.h.cl;
      
      if( atr & 0x10 )
	buf->st_mode = S_IFDIR|S_IRWXU|S_IRWXG|S_IRWXO;
      else if( !(atr & 0x08) ){
	int len = strlen (p);
	buf->st_mode = S_IFREG|S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH;
	if( atr & 0x01 )
	  buf->st_mode = S_IFREG|S_IRUSR|S_IRGRP|S_IROTH;
	if( (len >= 5) && (stricmp (&p[len - 4], ".com") == 0 ||
			   stricmp (&p[len - 4], ".exe") == 0 ||
			   stricmp (&p[len - 4], ".bat") == 0) )
	  buf->st_mode |= S_IXUSR|S_IXGRP|S_IXOTH;
      }
      if( atr & 0x06 )
	buf->st_mode &= ~(S_IRWXG|S_IRWXO);
    }
  }

  return status? -1: 0;
}
#endif

/*
 * ================================================================
 * SETENV.C
 * ================================================================
 */
/* This file may have been modified by DJ Delorie (Jan 1991).  If so,
** these modifications are Coyright (C) 1993 DJ Delorie, 24 Kirsten Ave,
** Rochester NH, 03867-2954, USA.
*/

/*
 * Copyright (c) 1987 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that: (1) source distributions retain this entire copyright
 * notice and comment, and (2) distributions including binaries display
 * the following acknowledgement:  ``This product includes software
 * developed by the University of California, Berkeley and its contributors''
 * in the documentation or other materials provided with the distribution
 * and in all advertising materials mentioning features or use of this
 * software. Neither the name of the University nor the names of its
 * contributors may be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#if defined(LIBC_SCCS) && !defined(lint)
static char sccsid[] = "@(#)setenv.c	5.4 (Berkeley) 6/1/90";
#endif /* LIBC_SCCS and not lint */

#include <stddef.h>
#include <stdlib.h>

extern char *_findenv();

/*
 * setenv --
 *	Set the value of the environmental variable "name" to be
 *	"value".  If rewrite is set, replace any current value.
 */
/* for Mule-2.3(19.29) 95.12.10  by K.Fujii */
static int alloced;
static char **old_environ;

void
init_env_internal (void)
{
  if (alloced && old_environ != NULL)
    {
      char **p;

      for (p = old_environ + alloced; *p; p++)
	free (*p);
      free (old_environ);
      alloced = 0;
      old_environ = NULL;
    }
}
/* end of patch */

#ifdef setenv
#undef setenv
#endif

int
setenv(name, value, rewrite)
	register const char *name, *value;
	int rewrite;
{
	extern char **environ;
/*	static int alloced; */			/* if allocated space before */
	register char *C;
	int l_value, offset;

	if (*value == '=')			/* no `=' in value */
		++value;
	l_value = strlen(value);
	if ((C = _findenv(name, &offset))) {	/* find if already exists */
		if (!rewrite)
			return(0);
		if (strlen(C) >= l_value) {	/* old larger; copy over */
			while ((*C++ = *value++));
			return(0);
		}
	}
	else {					/* create new slot */
		register int	cnt;
		register char	**P;

		for (P = environ, cnt = 0; *P; ++P, ++cnt);
		if (alloced) {			/* just increase size */
			environ = (char **)realloc((char *)environ,
			    (size_t)(sizeof(char *) * (cnt + 2)));
			if (!environ)
				return(-1);
		}
		else {				/* get new space */
			alloced = cnt;		/* copy old entries into it */
			P = (char **)malloc((size_t)(sizeof(char *) *
			    (cnt + 2)));
			if (!P)
				return(-1);
			bcopy(environ, P, cnt * sizeof(char *));
			environ = P;
		}
		environ[cnt + 1] = NULL;
		old_environ = environ;
		offset = cnt;
	}
	for (C = (char *)name; *C && *C != '='; ++C);	/* no `=' in name */
	if (!(environ[offset] =			/* name + `=' + value */
	    malloc((size_t)((int)(C - name) + l_value + 2))))
		return(-1);
	for (C = environ[offset]; (*C = *name++) && *C != '='; ++C);
	for (*C++ = '='; (*C++ = *value++););
	return(0);
}

/*
 * unsetenv(name) --
 *	Delete environmental variable "name".
 */
void
unsetenv(name)
	const char	*name;
{
	extern char **environ;
	register char **P;
	int offset;

	while (_findenv(name, &offset))		/* if set multiple times */
		for (P = &environ[offset];; ++P)
			if (!(*P = *(P + 1)))
				break;
}

/*
 * ================================================================
 * DIR.C
 * ================================================================
 */

#ifdef opendir
#undef opendir
#endif

DIR *opendir(char *name)
{
  int length;
  DIR *dir = (DIR *)malloc(sizeof(DIR));
  dir->num_read = 0;
  dir->name = (char *)malloc(strlen(name)+6);
  strcpy(dir->name, name);

  /* Append a "." if we got only the device name */
  if (dir->name[1] == ':' && strlen(dir->name) == 2)
      strcat(dir->name, ".");

  /* Strip trailing slashes, so we can append "/ *.*" */
  while (1)
  {
      length = strlen(dir->name);
      if (length == 0) break;
      if (dir->name[length - 1] == '/' ||
	  dir->name[length - 1] == '\\')
	  dir->name[length - 1] = '\0';
      else
	  break;
  }

  strcat(dir->name, "/*.*");
  return dir;
}

#ifdef readdir
#undef readdir
#endif

struct dirent *readdir(DIR *dir)
{
  int done;
  int oerrno = errno;
  if (dir->num_read)
    done = findnext(&dir->ff);
  else
    done = findfirst(dir->name, &dir->ff,
		     FA_ARCH|FA_RDONLY|FA_DIREC|FA_HIDDEN|FA_SYSTEM);
  if (done)
  {
    if (errno == ENMFILE)
      errno = oerrno;
    return 0;
  }
  dir->num_read ++;
  dir->de.d_namlen = strlen(dir->ff.ff_name);
#if 1  /* 94.10.2  by K.Fujii */
  {
    unsigned char *op = (unsigned char *) dir->de.d_name;
    unsigned char *ip = (unsigned char *) dir->ff.ff_name;

    while (*ip)
      {
	if (iskanji (*ip) && iskanji2 (ip[1]))
	  {
	    *op++ = *ip++;
	    *op++ = *ip++;
	  }
	else if (*ip >= 'A' && *ip <= 'Z')
	  *op++ = (*ip++) | 0x20;
	else
	  *op++ = *ip++;
      }
    *op++ = '\0';
  }
#else
  strcpy(dir->de.d_name,dir->ff.ff_name);
  strlwr(dir->de.d_name);
#endif
  return &dir->de;
}

long telldir(DIR *dir)
{
  return dir->num_read;
}

void seekdir(DIR *dir, long loc)
{
  int i;
  rewinddir(dir);
  for (i=0; i<loc; i++)
    readdir(dir);
}

void rewinddir(DIR *dir)
{
  dir->num_read = 0;
}

int closedir(DIR *dir)
{
  free(dir->name);
  free(dir);
  return 0;
}

