/* common.h */

#ifndef __COMMON_H__
#define __COMMON_H__

extern int __crt0_mtype;
#define _go32_machine_type __crt0_mtype

#define __AT           0x00
#define __PC98         0x10
#define __FM           0x20
#define __TOWNS        0x30
#define __MACHINE_MASK 0xf0
#define __MODE_MASK    0x0f
#define __DOSV         0x01
#define __PCAT         0x00

#define MachinePc98() (__crt0_mtype == __PC98)
#define MachineDOSV() ((__crt0_mtype & __MACHINE_MASK) == __AT)
#define MachinePCAT() ((__crt0_mtype & __MACHINE_MASK) == __AT)
#define MachineFM()    (__crt0_mtype == __FM)
#define MachineTOWNS() (__crt0_mtype == __TOWNS)
#define ModeDOSV()     (__crt0_mtype == __DOSV)
#define ModePCAT()     (__crt0_mtype == __PCAT)

#define JMP_MACHINE ((__crt0_mtype >> 4) & 0x0f)
#define JMP_MODE     (__crt0_mtype & 0x0f)

#include <screen.h>

#endif /* __COMMON_H__ */
