/* This file may have been modified by DJ Delorie (Jan 1991).  If so,
** these modifications are Coyright (C) 1991 DJ Delorie, 24 Kirsten Ave,
** Rochester NH, 03867-2954, USA.
*/

/*
 Here's a ctype.h for SunOS-3 and vax 4.3BSD.  
 It will probably work on most BSD derived systems. 
 Just compare it to the C version to verify.
 No big deal, but it will save you some typing.
*/

/*  Modified for Shift-JIS Code by Y.Shibata(FATMAN)  1992 Jun 6th  */

#ifndef _jctype_h
#define _jctype_h
 
#include <stdio.h>  /* sorry, but needed for USG stuff */
   
#define _KK	01
#define _KP	02
#define _KF	0100
#define _KS	0200

#ifdef DGUX
#define JCTYPE_TYPE      short
#else
#define JCTYPE_TYPE      char
#endif

#if defined(DGUX) || defined(USG) || defined(hpux)
#define _jctype_ _jctype_
#endif

#ifdef __cplusplus
extern "C" {
#endif
extern  JCTYPE_TYPE      _jctype_[];
#ifdef __cplusplus
}
#endif

#define iskana(c)       ((_jctype_+1)[(unsigned char)(c)] & (_KK|_KP))
#define iskmoji(c)      ((_jctype_+1)[(unsigned char)(c)] & _KK)
#define iskpun(c)       ((_jctype_+1)[(unsigned char)(c)] & _KP)

#define iskanji(c)      ((_jctype_+1)[(unsigned char)(c)] & _KF)
#define iskanji2(c)     ((_jctype_+1)[(unsigned char)(c)] & _KS)

#define isalkana(c)     (isalpha(c) || iskmoji(c))
#define isalnmkana(c)   (isalnum(c) || iskmoji(c))
#define isgrkana(c)     (isgraph(c) || iskana(c) )
#define ispnkana(c)     (ispunct(c) || iskpun(c) )
#define isprkana(c)     (isprint(c) || iskana(c) )

#ifdef _jctype_
#undef _jctype_
#endif

#ifdef JCTYPE_TYPE
#undef JCTYPE_TYPE
#endif

#endif _jctype_h
