/* Copyright (C) 1991 Free Software Foundation, Inc.
This file is part of the GNU C Library.

The GNU C Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The GNU C Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with the GNU C Library; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.  */

/*  Modified for Shift-JIS Code by Y.Shibata(FATMAN)  1992 Jun 6th  */

#if 0
#include <ansidecl.h>
#include <localeinfo.h>
#endif
#include <ctype.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <jctype.h>

#if 0
long int _mb_shift = 0;
#endif

/* Convert the multibyte character at S, which is no longer
   than N characters, to its `wchar_t' representation, placing
   this n *PWC and returning its length.  */
int	mbtowc (wchar_t *pwc ,const char *s ,size_t n)
{
  int	   length = 1;		/*  ANK Char width  */
  register wchar_t i;

  if ((s == NULL)||(*s == '\0')||(n == 0))
    return 0;
  if (iskanji(i = *s & 0xff))
    {
    if (iskanji2(*(++s)) && (n > 1))
      {
      i <<= 8;
      i  |= *s & 0xff;
      length++;			/*  Shift-JIS Width = 2Byte  */
      }
    else
      return -1;		/*  Invalid Shift-JIS Code  */
    }
  if (pwc != NULL)
    *pwc = i;
  return length;		/*  Return Char Width  */
}
